#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

# TODO revisión de los imports copiados de certificado.py
import cgi
import cgitb; cgitb.enable()
import os
import os.path
from M2Crypto import RSA, m2, X509, EVP,Rand, Err
import time
import datetime
import xml
from xml.dom import minidom
from types import *

import lib.miarc_util


class XML:
	def __init__(self, pathArchivo = None):
		"""Método constuctor"""
		self.path = None
		if pathArchivo != None:
			self.path = pathArchivo

	def valor (etiqueta):
		"""Función que devuelve el valor de una etiqueta en el archivo XML"""
		pass
		

class XMLReq(XML):
	""" Clase asociada al XML que se importa de la RA.
	"""

	def addAttribute (self, idReq, nombre, valor):
		xmldoc = minidom.parse(self.path)
		reqLista = xmldoc.getElementsByTagName('request')
		l = len(reqLista)
		i = 0
		encontradaReq = False
		while i<l and not encontradaReq:
			if reqLista[i].attributes['id'].value == idReq:
				reqLista[i].setAttribute(nombre, valor)
				encontradaReq = True
			i = i+1
		nuevoCont = xmldoc.toxml()
		fXml = open (self.path, 'w')
		fXml.write(nuevoCont.encode('UTF-8'))
		fXml.close()

	def cambiaEstado (self, idReq, nuevoEstado):
		""" Cambia el estado de la petición con identificador idReq por el indicado en 
			nuevoEstado.
		"""
		xmldoc = minidom.parse(self.path)
		reqLista = xmldoc.getElementsByTagName('request')
		l = len(reqLista)
		i = 0
		encontradaReq = False
		while i<l and not encontradaReq:
			if reqLista[i].attributes['id'].value == idReq:
				reqLista[i].getElementsByTagName('estado').item(0).firstChild.data = nuevoEstado
				encontradaReq = True
			i = i+1
		nuevoCont = xmldoc.toxml()
		fXml = open (self.path, 'w')
		fXml.write(nuevoCont.encode('UTF-8'))
		fXml.close()


	def importar(self, contForm):
		""" Método que importa el XML con las peticiones desde el formulario 
			hasta el archivo /requests/requests.xml
		"""
		dirAct = os.getcwd()
		pathXmlReq = dirAct + '/requests/requests.xml'
		xmldoc = minidom.parseString(contForm.contXML)

		if not os.path.exists(pathXmlReq):		# si es la primera vez que se importan peticiones
			# Añade la fecha de importación como atributo a cada etiqueta <request> y copia
			self.insertDate(xmldoc)
			x = xmldoc.toxml(encoding="UTF-8")
			f = open(pathXmlReq, 'w')
			f.write (x)
			f.close()
		else:									# si NO es la primera vez que se importan peticiones
			# Comprobando que las peticiones no han sido ya importadas
			# ¿Cómo? petición por petición comprobamos si su id es menor o igual 
			# que la mayor id de las ya importadas y en ese caso la borramos
			
			xmldocReq = minidom.parse(pathXmlReq)
			reqRegLista = xmldocReq.getElementsByTagName('request')
			lR = len(reqRegLista)
			idMax = reqRegLista[lR-1].attributes['id'].value		# se almacenan por orden por tanto nos ahorramos la búsqueda

			reqsLista = xmldoc.getElementsByTagName('requests')
			reqLista = xmldoc.getElementsByTagName('request')
			l = len(reqLista)
			newReq = False
			while l>0:
				if int(reqLista[l-1].attributes['id'].value) <= int(idMax):
					reqsLista[0].removeChild(reqLista[l-1])
				else:
					newReq = True
				l -= 1

			# Añadir la fecha de importación como atributo a cada etiqueta <request>
			
			self.insertDate(xmldoc)
			x = xmldoc.toxml(encoding = "UTF-8")

			if newReq:
				f = open(pathXmlReq, 'r+w')
				f.seek(-12, 2)				# desplazamos justo antes de </requests>
				f.write(x[48:]) 			# el contenido sin las dos primeras lineas
				f.close()
			# función que genera las IDpeticion.html
			self.generarIdReqHtmls(xmldoc)


	def generarIdReqHtmls(self, xmldoc = None):
		""" Crea los idPeticion.html en el directorio /web/requests/ para 
			con las vistas de las configuraciones de las peticiones importadas
		"""
		if xmldoc != None:
			tuplaListas = self.parseoXML (xmldoc)
			l = len(tuplaListas[0])
			if l>0:
				dirAct = os.getcwd()
				dirReq = dirAct + '/web/requests/'
				while l>0:
					# generar la lista con la info de una petición
					i = 0
					lista = []
					while i < len(tuplaListas):
						lista.append(tuplaListas[i][l-1])
						i = i+1
					cont = self.contReqHtml(lista)

					fHtml = open (dirReq + 'id_' + tuplaListas[0][l-1] + '_req.html', 'w')
					fHtml.write(cont.encode('utf-8'))
					fHtml.close()
					l = l-1


	def contReqHtml (self, lista):
		""" Genera el código HTML de la página idReq.html cuyos valores son 
			los contenidos en la tupla argumento.
		"""
		# Lista de las CAs que puedan firmar la petición
		objXMLCa = XMLCA()
		listaCAs = objXMLCa.getCAsPost(lista[17])
		# Generación del código a incrustar en el html
		htmlElement = ""
		for idCA in listaCAs:
			htmlElement += "\n\t\t\t\t<option>" + idCA + "</option>"

		# Tratamiento del valor codificado en el XML del uso del certificado
		if lista[16] == '1':
			lista[16] = "S/MIME"
		elif lista[16] == '2':
			lista[16] = "Cifrado"
		elif lista[16] == '3':
			lista[16] = "Cliente SSL"
		elif lista[16] == '4':
			lista[16] = "Servidor SSL"
		elif lista[16] == '5':
			lista[16] = "Certificado de CA"
		else:
			lista[16] = "Firma Código/Objeto"

		# Creación del código HTML
		htmlCode = unicode ("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>Petición de Certificado Digital número """ + str(lista[0].encode('utf-8')) + """</title>
	<link rel="stylesheet" type="text/css" href="../estiloInd.css" media="all">
	<script type="text/javascript">
		function mostrar(enla) {
		  obj = document.getElementById('oculto');
		  obj.style.visibility = (obj.style.visibility == 'hidden') ? 'visible' : 'hidden';
		  enla.innerHTML = (enla.innerHTML == 'Ocultar Password') ? 'Mostrar Password' : 'Ocultar Password';
		}
	</script>
</head>

<!--
			<input type=hidden id="idCA" name="idCA" class="element text medium" type="text" maxlength="255" value=''/>
			<input type=hidden id="passwCA" name="passwCA" class="element text medium" type="text" maxlength="255" value=''/>
-->

<body id="main_body" >
	<img id="top" src="../images/top.png" alt="">
	<img src="../images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../index.html" /></map>
	<div id="contenedor">
		<br>
		<form id="form_43076" class="appnitro"  method="post" action="http://localhost:8000/cgi-bin/prevReq.py" onSubmit = "return validar(this)">
		<div class="form_description">
			<h2>Petición número: """ + str(lista[0].encode('utf-8')) + """</h2>
			<p>A continuación se encuentra la información que ha ingresado el cliente en el formulario para solicitar un certificado digital, al fondo dispone de la opciones que le permiten aceptar o rechazar la petición.</p>
			<ul>
			<div class="section_break">
				<h3>Identificación del Peticionario.</h3>
				<p>Datos de la persona física o jurídica que deberá de demostrar propios mediante su documentación a efectos de cotejación a la hora de recoger el certificado.</p>
			</div>
			<li id="li_1" >
				<label class="description" for="identificacion">Número o Código de Identificación Fiscal: </label>
				<div>
					""" + str(lista[1].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_22" >
				<label class="description" for="codigo">Código de Seguridad: </label>
				<div>
					""" + str(lista[18].encode('utf-8')) + """
				</div>
			</li>
			<div class="section_break">
				<h3>Información del Titular.</h3>
				<p>Información de la persona, organización o empresa que será titular del certificado, esta información formará parte del propio certificado y tendrán acceso a ella los usuarios del mismo.</p>
			</div>
			<li id="li_2" >
				<label class="description" for="comName">Nombre Común (CN): </label>
				<div>
					""" + str(lista[2].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_3" >
				<label class="description" for="surname">Apellido (SN): </label>
				<div>
					""" + str(lista[3].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_4" >
				<label class="description" for="givName">Sobrenombre (GN): </label>
				<div>
					""" + str(lista[4].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_5" >
				<label class="description" for="serial">Número de Serie: </label>
				<div>
					""" + str(lista[8].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_6" >
				<label class="description" for="org">Organización (O): </label>
				<div>
					""" + str(lista[5].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_7" >
				<label class="description" for="uniOrg">Unidad Organizativa (OU): </label>
				<div>
					""" + str(lista[6].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_8" >
				<label class="description" for="emaCont">Email: </label>
				<div>
					""" + str(lista[7].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_9" >
				<label class="description" for="ciudad">Ciudad: </label>
				<div>
					""" + str(lista[9].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_10" >
				<label class="description" for="provincia">Provincia: </label>
				<div>
					""" + str(lista[10].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_11" >
				<label class="description" for="pais">País: </label>
				<div>
					""" + str(lista[11].encode('utf-8')) + """
				</div>
			</li>
			<div class="section_break">
				<h3>Uso del Certificado.</h3>
				<p>	Usos para los cuales será utilizado el certificado digital.</p>
			</div>
			<li id="li_16" >
				<label class="description" for="pais">Uso del certificado: </label>
				<div>
					""" + str(lista[16].encode('utf-8')) + """
				</div>
			</li>
			<div class="section_break">
				<h3>Claves Pública y Privada.</h3>
				<p>Datos necesarios para generar el par de claves RSA asociadas al Certificado Digital.</p>
			</div>
			<li id="li_17" >
				<label class="description" for="numBits">Número de bits de la Clave Privada: </label>
				<div>
					""" + str(lista[12].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_18" >
				<label class="description" for="exp">Exponente: </label>
				<div>
					""" + str(lista[13].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_19" >
				<label class="description" for="password">Password: </label>
				Por razones de seguridad el password se mantiene oculto por defecto, si desea verlo pulse sobre el siguiente enlace: <a href="#" onclick="mostrar(this); return false" />Mostrar Password</a>.
				<div id="oculto" style="visibility:hidden">
					Password: """ + str(lista[14].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_20">
				<label class="description" for="firma">Algoritmo de Firma: </label>
				<div>
					""" + str(lista[15].encode('utf-8')) + """
				</div>
			</li>
			<div class="section_break">
				<h3>Validez del Certificado</h3>
				<p>El certificado será válido a partir del momento de emisión hasta la fecha que elija a continuación.</p>
			</div>		
			<li id="li_21" >
				<label class="description" for="fechaCaduc">Fecha de Caducidad: </label>
				<div>
					""" + str(lista[17].encode('utf-8')) + """
				</div>
			</li>
			<div class="section_break">
				<h3>Tratamiento de la Petición</h3>
				<p>El tratamiento de la petición se reduce a dos posibilidades, emitir el certificado digital peticionado o rechazar la petición, en el primer caso elija a continuación la Autoridad de Certificación con la que desea firmar el certificado.</p>
			</div>	
			<li id="li_23" >
				<label class="description" for="cas">Autoridades de Certificación aptas para firmar la petición: </label>
				<div>
					<select name="menuCAs">""" + str(htmlElement.encode('utf-8')) + """
					</select>
				</div>
			</li>
			<div align="center" class="buttons">
				<input type="hidden" name="form_id" value="43076" />
				<input id="saveForm" class="button_text" type="submit" name="submit" value="Emitir Certificado" />
				<input id="saveForm" class="button_text" type="submit" name="submit" value="Rechazar Petición" />
			</div>
		</div>
		</ul>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
		return htmlCode


	def insertDate(self, xmldoc):
		""" Inserta un atributo llamado importDate en cada etiqueta <request>
		"""
		reqLista = xmldoc.getElementsByTagName('request')
		l = len(reqLista)
		while l>0:
			reqLista[l-1].setAttribute('importDate', time.ctime())
			l = l-1


	def parseoXML (self, xmldoc = None):
		""" Realiza un análisis del argumento 'xmldoc' 
		para obtener los valores del atributo 'id' y de todas las etiquetas 
		de todas las peticiones en el xmldoc.

		Devuelve una tupla de listas.
		"""

		# Obteniendo los valores de '/web/CAs/CAs.xml'
		idReq = []		# se refiere a la etiqueta <id>, pero id es palabra reservada de Python
		idDocument = []	# documento de identificación de la persona o entidad
		cn = []			# common name
		sn = []			# surname
		gn = []			# given name
		o = []			# organization
		ou = []			# organization unit
		email = []		# email
		serial = []		# serial (introducido por el cliente)
		loc = []		# location
		st = []			# state/province/region
		pais = []		# country
		numBits = []	# número de bits del módulo público
		exponente = []	# exponente RSA
		password = []	# password
		algFirma = []	# algoritmo de firma
		uso = []		# uso del certificado
		fechaCad = []	# fecha de caducidad del certificado
		codigo = []		# código de seguridad que proporciona el sistema tras la petición

		if xmldoc != None:
			reqLista = xmldoc.getElementsByTagName('request')
			l = len(reqLista)
			i = 0
			while i < l:
				idReq.append (reqLista[i].attributes["id"].value)
				idDocument.append (reqLista[i].getElementsByTagName('idDocument').item(0).firstChild.data)
				cn.append (reqLista[i].getElementsByTagName('cn').item(0).firstChild.data)
				sn.append (reqLista[i].getElementsByTagName('sn').item(0).firstChild.data)
				o.append (reqLista[i].getElementsByTagName('o').item(0).firstChild.data)
				ou.append (reqLista[i].getElementsByTagName('ou').item(0).firstChild.data)
				email.append (reqLista[i].getElementsByTagName('email').item(0).firstChild.data)
				loc.append (reqLista[i].getElementsByTagName('loc').item(0).firstChild.data)
				st.append (reqLista[i].getElementsByTagName('st').item(0).firstChild.data)
				pais.append (reqLista[i].getElementsByTagName('pais').item(0).firstChild.data)
				numBits.append (reqLista[i].getElementsByTagName('numBits').item(0).firstChild.data)
				exponente.append (reqLista[i].getElementsByTagName('exponente').item(0).firstChild.data)
				password.append (reqLista[i].getElementsByTagName('password').item(0).firstChild.data)
				algFirma.append (reqLista[i].getElementsByTagName('algFirma').item(0).firstChild.data)
				uso.append (reqLista[i].getElementsByTagName('uso').item(0).firstChild.data)
				fechaCad.append (reqLista[i].getElementsByTagName('fechaCad').item(0).firstChild.data)
				codigo.append (reqLista[i].getElementsByTagName('codigo').item(0).firstChild.data)
				# El peticionario puede dejar en blanco los campos "Given Name" y "Serial"
				if not type(reqLista[i].getElementsByTagName('gn').item(0).firstChild) is NoneType:
					gn.append (reqLista[i].getElementsByTagName('gn').item(0).firstChild.data)
				else:
					gn.append ('Valor no insertado.')
				if not type(reqLista[i].getElementsByTagName('serial').item(0).firstChild) is NoneType:
					serial.append (reqLista[i].getElementsByTagName('serial').item(0).firstChild.data)
				else:
					serial.append ('Valor no insertado.')
				i = i+1
		return (idReq, idDocument, cn, sn, gn, o, ou, email, serial, loc, st, pais, numBits, exponente, password, algFirma, uso, fechaCad, codigo)


class XMLCA(XML):

	def getCAsPost (self, fechaCad):
		""" Realiza un parsea del documento /web/CAs/CAs.xml y devuelve una 
			lista con los idCAs de aquellas CAs cuyo <estado> sea 'valido' 
			y cuya <fechaRev> sea anterior a la indicada en el argumento fechaCad
		"""
		dirAct = os.getcwd()
		pathXml = dirAct + '/web/CAs/CAs.xml'
		listaCAs = []
		if os.access(pathXml, os.F_OK):
			xmldoc = minidom.parse(pathXml)
			CALista = xmldoc.getElementsByTagName('ca')
			l = len(CALista)
			while l>0:
				if CALista[l-1].getElementsByTagName('estado').item(0).firstChild.data == 'valido' and lib.miarc_util.compFecha (fechaCad, CALista[l-1].getElementsByTagName('fechaRev').item(0).firstChild.data):
					listaCAs.append(CALista[l-1].attributes['id'].value)					
				l = l-1
		return listaCAs


	def crear (self):
		""" Crea el archivo CAs.xml
		"""
		dirAct = os.getcwd()
		pathXml = dirAct + '/web/CAs/CAs.xml'
		if not os.access(pathXml, os.F_OK):
			fXml = open (pathXml, 'w')		# crea el archivo CAs.xml
			fecha = str(datetime.date.today())
			anyo = fecha[0:4]
			mes = fecha[5:7]
			dia = fecha[8:10]
			etiquetaRaiz = """<?xml version="1.0"  encoding="UTF-8"?>\n<miARC-CAs fechaUltAcc='""" + dia + '-' + mes + '-' + anyo + """'>"""	# fecha del último acceso
			etiquetaFin = "\n</miARC-CAs>"
			contenido = etiquetaRaiz + etiquetaFin
			fXml.write(contenido)
			fXml.close()
		else:
			print "ERROR: El archivo CAs.xml ya existe."

	def actualiza (self, cert):
		dirAct = os.getcwd()
		pathXml = dirAct + '/web/CAs/CAs.xml'
		if not os.access(pathXml, os.F_OK):	# controla si el archivo CAs.xml no existe y se crea
			fXml = open (pathXml, 'w')		# el archivo CAs.xml ya debería estar creado
			fechaActual = time.gmtime()
			# cambiamos el formato anterior a: DD-MM-AAAA
			dia = str(fechaActual[2])
			mes = str(fechaActual[1])
			anyo = str(fechaActual[0])
			if len(dia) == 1:
				dia = '0' + dia
			if len(mes) == 1:
				mes = '0' + mes
			fechaActFormat = dia + '-' + mes + '-' + anyo
			etiquetaRaiz = """<?xml version="1.0"  encoding="UTF-8"?>\n<miARC-CAs fechaUltAcc='""" + fechaActFormat + """'>"""	# fecha del último acceso
			fXml.write(etiquetaRaiz)
		else:
			fXml = open (pathXml, 'r+w')		# abre el ya existente CAs.xml
			fXml.seek(-13, 2)					# desplazamos justo antes de </miARC-CAs>
		lCert = generaEstXML(cert)			# lista de cadenas con las filas de la estructura XML del certificado
		lCert.append("\n</miARC-CAs>")		# restauramos la etiqueta de cierre del elemento raíz
		fXml.writelines(lCert)
		fXml.close()

	def getClave (self, idCA):
		""" Devuelve el contenido de la etiqueta clave en CAs.xml"""
		dirAct = os.getcwd()
		path = dirAct + "/web/CAs/CAs.xml"
		clave = ''
		xmldoc = minidom.parse(path)
		CALista = xmldoc.getElementsByTagName('ca')
		l = len(CALista)
		encontrado = False
		i=0
		while i<l and not encontrado:
			if CALista[i].attributes['id'].value == idCA:
				clave = CALista[i].getElementsByTagName('clave').item(0).firstChild.data
				encontrado = True
			else:
				i=i+1
		return clave


	def revocaCerts(self, idCA):		# revoca todos los certs emitidos y activos
		""" Cambia el valor de la etiqueta <estado> a 'revocado' en todos los 
			certificados emitidos y que tengan el valor 'activo'.
		"""
		xmldoc = minidom.parse(self.path)
		certsLista = xmldoc.getElementsByTagName('cert')
		l = len(certsLista)
		i = 0
		while i<l:
			if certsLista[i].getElementsByTagName('estado').item(0).firstChild.data == 'valido':
				certsLista[i].getElementsByTagName('estado').item(0).firstChild.data = 'revocado'
			i = i+1
		nuevoCont = xmldoc.toxml()
		fXml = open (self.path, 'w')
		fXml.write(nuevoCont)
		fXml.close()


	def copiaSeg (self):
		pass


	def controlCad (self):
		""" Compara la fecha actual del sistema con la contenida en el atributo 
			'fechaUltAcc' de CAs.xml y devuelve un lógico indicando si la actual es 
			posterior a la almacenada. 
		"""
		xmldoc = minidom.parse(self.path)
		nodoRaiz = xmldoc.getElementsByTagName('miARC-CAs')
		fechaUltAcc = nodoRaiz[0].getElementsByTagName('fechaUltAcc').item(0).firstChild.data
		if comparaConFechaAct (fechaUltAcc):
			self.actualizaEstados(xmldoc)


	def actualizaEstados (self, xmldoc):
		""" Consulta todas las fechas de caducidad de las CAs y en el caso en 
			que alguna sea anterior a la actual cambia su <estado> a 'caducado'
		"""
# XXX REVISAR PARA MI QUE NO FUNCIONA
		CALista = xmldoc.getElementsByTagName('ca')
		l = len(CALista)
		i=0
		while i<l:
			fechaCad = CALista[i].attributes['fechaRev'].value		# fechaRev es la fecha de caducidad
			if comparaConFechaAct (fechaCad):
				CALista[i].getElementsByTagName('estado').item(0).firstChild.data = 'caducado'
				i=i+1


	def cambiaEstado (self, idCA, nuevoEstado):
		""" Cambia el estado de la CA con identificador idCA por el indicado en 
			nuevoEstado.
		"""
		xmldoc = minidom.parse(self.path)
		CALista = xmldoc.getElementsByTagName('ca')
		l = len(CALista)
		i = 0
		encontradaCA = False
		while i<l and not encontradaCA:
			if CALista[i].attributes['id'].value == idCA:
				CALista[i].getElementsByTagName('estado').item(0).firstChild.data = nuevoEstado
				encontradaCA = True
			i = i+1
		nuevoCont = xmldoc.toxml()
		fXml = open (self.path, 'w')
		fXml.write(nuevoCont.encode('UTF-8'))
		fXml.close()


def comparaConFechaAct (fecha):		# fecha: string AAAA-MM-DD
	"""Compara la fecha pasada como argumento con la del sistema y devuelve un 
	lógico indicando si la pasada como argumento es anterior."""
	anyo = fecha[0:4]
	mes = fecha[5:7]
	dia = fecha[8:10]
	res = True
	tupTime = time.localtime()
	if anyo < tupTime.tm_year:
		res = True
	elif anyo > tupTime.tm_year:
		res = False
	else:
		if mes < tupTime.tm_mon:
			res = True
		elif mes > tupTime.tm_mon:
			res = False
		else:
			if dia < tupTime.tm_mday:
				res = True
			else:
				res = False
	return res



class XMLCert (XML):

	def crear (self, idCA):
		""" Crea el archivo certs.xml para la CA cuyo idCA se pasa como argumento, 
		certs.xml contendrá los campos del subject name de los certificados 
		emitidos con dicha CA.
		"""

		# generando la cadena con la fecha actual para el atributo fechaUltRevCad
		fechaActString = lib.miarc_util.fechaActCad()

		dirAct = os.getcwd()
		pathXml = dirAct + '/web/CAs/' + idCA + '/certs.xml'
		if not os.path.exists(pathXml):
			fXml = open (pathXml, 'w')		# crea el archivo certs.xml
			# fechaUltRevCad sirve para identificar el último día que se revisó si había caducado algún certificado
			contenido = """<?xml version="1.0" encoding="UTF-8"?>\n<CA id='""" + idCA + """' fechaUltRevCad = '""" + fechaActString + """'>\n</CA>"""
			fXml.write(contenido)
			fXml.close()
		else:
			print "ERROR: Se ha intentadao crear el archivo: '" + pathXml + "' que ya existe."


	def actualiza (self, cert):
		""" Actualización del contenido del archivo certs.xml almacenando toda la 
		información relevante del certificado pasado como argumento.

			@type cert: Certificado object
			@param cert: Objeto de la clase Certificado del módulo certificado.py.
		"""
		dirAct = os.getcwd()
		pathXml = dirAct + '/web/CAs/' + cert.idCA + '/certs.xml'
		if not os.access(pathXml, os.F_OK):
			fXml = open (pathXml, 'w')		# el archivo certs.xml ya debería estar creado
			etiquetaRaiz = """<?xml version="1.0" encoding="UTF-8"?>\n<CA id='""" + cert.idCA + """'""" + """fechaUltMod='""" + str(datetime.date.today()) + """'>"""
			fXml.write(etiquetaRaiz)
		else:
			fXml = open (pathXml, 'r+w')		# abre el ya existente certs.xml
			fXml.seek(-6, 2)					# desplazamos justo antes de </CA>
		lCert = generaEstXML(cert)			# lista de cadenas con las filas de la estructura XML del certificado
		lCert.append("\n</CA>")				# restauramos la etiqueta de cierre del elemento raíz
		fXml.writelines(lCert)
		fXml.close()


	def revocar(self, serie):
		"""Dado el número de serie del certificado se cambia el valor de la etiqueta <estado> a revocado"""
		xmldoc = minidom.parse(self.path)
		certLista = xmldoc.getElementsByTagName('cert')
		l = len(certLista)
		encontrado = False
		i=0		
		while i<l and not encontrado:
			if certLista[i].attributes['numSer'].value == serie:
				certLista[i].getElementsByTagName('estado').item(0).firstChild.data = 'revocado'
				encontrado = True
			else:
				i=i+1
		archAct = xmldoc.toxml()
		fXml = open (self.path, 'w')
		fXml.write(archAct.encode('UTF-8'))
		fXml.close()


	def copiaSeg (self):
		pass


def generaEstXML (infoCert):
	""" Recibe un certificado digital como argumento y genera una lista de 
		cadenas que conforman una estructura XML sintácticamente válida con la 
		información a almacenar.
	"""
	lXML = []

	if not infoCert.tipoCA:
		raizInicNodo = "\n\t<cert numSer='" + str(infoCert.numSer) + "'>"
		raizFinNodo = "\n\t</cert>"
	else:
		raizInicNodo = "\n\t<ca id='" + str(infoCert.idCA) + "'>"
		raizFinNodo = "\n\t</ca>"

	cnNodo = "\n\t\t<cn>" + infoCert.cn + "</cn>"
	snNodo = "\n\t\t<sn>" + infoCert.sn + "</sn>"
	gnNodo = "\n\t\t<gn>" + infoCert.gn + "</gn>"
	paisNodo = "\n\t\t<pais>" + infoCert.pais + "</pais>"
	stNodo = "\n\t\t<st>" + infoCert.st + "</st>"
	locNodo = "\n\t\t<loc>" + infoCert.loc + "</loc>"
	oNodo = "\n\t\t<o>" + infoCert.o + "</o>"
	ouNodo = "\n\t\t<ou>" + infoCert.ou + "</ou>"
	emailNodo = "\n\t\t<email>" + infoCert.mail + "</email>"
	serialNodo = "\n\t\t<serial>" + infoCert.serial + "</serial>"
	extNodo = "\n\t\t<ext>" + "PENDIENTE DE IMPLEMENTACION (EXTENSIONES)" + "</ext>"

	# añadidos
	fechaRevocacion = "\n\t\t<fechaRev>" + infoCert.fechaCaducidad + "</fechaRev>"
	clave = "\n\t\t<clave>" + infoCert.passw + "</clave>"
	estado = "\n\t\t<estado>valido</estado>"

	lXML.append(raizInicNodo)
	lXML.append(cnNodo)
	lXML.append(snNodo)
	lXML.append(gnNodo)
	lXML.append(paisNodo)
	lXML.append(stNodo)
	lXML.append(locNodo)
	lXML.append(oNodo)
	lXML.append(ouNodo)
	lXML.append(emailNodo)
	lXML.append(serialNodo)
	lXML.append(extNodo)

	# añadidos
	lXML.append(fechaRevocacion)
	lXML.append(clave)
	lXML.append(estado)

	lXML.append(raizFinNodo)

	return lXML


