#!/usr/bin/env python

import cgi
import cgitb; cgitb.enable()
import os
import os.path
from M2Crypto import X509

class CFormulario:
	def __init__(self):
		"""Mapeo y control de errores en el servidor del formulario de entrada.

		@rtype: tupla.
		@return: objeto tupla.
		El primer elemento de la tupla indica si el formulario tiene cumplimentados los campos obligatorios con valores validos, 
			Si tupla[0]==False, tupla[1] es una cadena con un mensaje de error.
			Si tupla[0]==True, el resto de la tupla contiene los valores ingresados en los campos del formulario ordenados.
		"""
		form = cgi.FieldStorage() # parsea la peticion, form se comporta como un diccionario
		self.idCA = form["idCA"].value

		# Path Certificado .pem
		if form.has_key("pathCert") and form["pathCert"].value != "":
			self.pC = form["pathCert"].value
		else: # si no se le da un nombre comun tomara por defecto el del nombre identificador
			self.pC = ''

		# Path PKey .pem
		if form.has_key("pathKey"):
			self.pK = form["pathKey"].value
		else: # Hay que ponerlo pq si se deja en blanco no se envia el campo => el if anterior responde False y no estaria declarado self.sn
			self.pK = ''


	def actualizaIndex (self, certObj):
		""" Actualiza el archivo /web/index.html anadiendo la informacion correspondiente a la nueva CA.
		"""
		infoCert = certObj.get_subject()
		nuevaInfo = """
		<li>
		<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
		<tbody>
		<tr>
			<td width="12%" class="imagen"><a href='./CAs/""" + self.idCA + """/""" + self.idCA + """.html'><img src="../web/CAs/candado.png" alt="" title="" border="0" height="60" width="60"></a></td>
			<td width="40%" class="preview"><p><strong>idCA: </strong>""" + self.idCA + """<br />
			  <strong>Nombre: </strong>""" + infoCert.CN + """<br />
			  <strong>Organizacion: </strong>""" + infoCert.O + """<br />
			  <strong>Fecha de Revocacion: </strong> niIdea </p></td>
			<td width="48%" class="enlace">
				<a href="" class=""><img src="../web/iconos/script_add.png" width="16" height="16" /> Emitir Nuevo Certificado</a><br/>
				<a href="" class=""><img src="../web/iconos/script_delete.png" width="16" height="16" /> Revocar Certificado</a><br/>
				<a href="" class=""><img src="../web/iconos/script_go.png" width="16" height="16" /> Obtener Lista de Revocacion de Certificados</a>
		</tr>
		</tbody>
		</table>
		</li>

		<div class="section_break"></div>
		"""
		dirAct = os.getcwd()
		path = dirAct + '/web/index.html'
		lon = len(path) - 139 # 105 son los bytes que hay desde el final del archivo a donde queremos anadir el <li>
		if os.access(path, os.F_OK):
			index = open(path, 'r')
			contenido = index.read()
			index.close()
			pre = contenido[:lon]
			pos = contenido[lon+1:]
			nuevoContenido = pre + nuevaInfo + pos
			index = open(path, 'w')
			index.write(nuevoContenido)
			index.close()
		else:
			print "ERROR: No se encuentra el archivo index.txt en el directorio web/"




def crearEst (dirRaiz, idCA):
    """Comprueba que no exista el fichero idCA en el directorio dirRaiz, 
	en caso afirmativo devuelve -1, en caso negativo crea los archivos y 
	la estructura de ficheros necesaria para una nueva CA de nombre 
	idCA colgando del directorio dirRaiz.

	@type dirRaiz: string
	@param dirRaiz: directorio del que cuelgan las ficheros con el contenido 
					de cada CA.

	@type idCA: string
	@param idCA: nombre del fichero que contendra los archivos y ficheros 
				necesarios para una CA y coincide con el nombre asignado a 
				la CA en el formulario asociado.
	"""

    if os.access(dirRaiz, os.W_OK): # comprobamos si existe y podemos escribir en dirRaiz
		dirCAs = dirRaiz + '/CAs/'		
		dirCA = dirCAs + idCA + '/'

		try:
			if os.access(dirCAs, os.F_OK) == False:
				os.mkdir(dirCAs, 0777)
			os.mkdir(dirCA, 0777)
		# crear los directorios /certs y /private
			os.mkdir(dirCA + "certs", 0777)
			os.mkdir(dirCA + "private", 0700)
		except IOError, (errno, strerror):
			print "Error de E/S(%s): %s" % (errno, strerror)

	    #creacion del archivo serial
		serial = open(dirCA + "serial", 'w')
		serial.write("01")
		serial.close()

	    #creacion del archivo track de certificados
		ind = open(dirCA + "index.txt", 'w')
		ind.close()


if __name__ == '__main__':
	print "Content-Type: text/html"     # sigue HTML
	print                               # linea en blanco, fin de la cabecera
	cf = CFormulario()

	dirAct = os.getcwd()
	crearEst(dirAct, cf.idCA)
	dirCA = dirAct + '/CAs/' + cf.idCA + '/'
	dirCAPrivate = dirCA + 'private/'

#	Parte correspondiente al Update del Certificado:
	CAcert = open(dirCA + "cacert.pem", 'w')
	CAcert.write(cf.pC)
	CAcert.close()

#	Parte correspondiente al Update de las claves RSA:
	CAKey = open(dirCAPrivate + "cakey.pem", 'w')
	CAKey.write(cf.pK)
	CAKey.close()

	certRaiz = X509.load_cert(dirCA + "cacert.pem")
	cf.actualizaIndex(certRaiz)
