#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

import cgi
import cgitb; cgitb.enable()
import os
from xml.dom import minidom
import time

import _xml
import lib.miarc_util

class CFormulario:
	def __init__(self):
		"""Mapeo y control de errores en el servidor del formulario de importación de peticiones.
		"""
		self.error = []									# lista con los codigos de error detectados al parsear el contenido del formulario
		form = cgi.FieldStorage(keep_blank_values=1)	# parsea la peticion sin ignorar los campos vacíos

		# Control de errores en el contenido del formulario de importación
		if form.has_key("pathXML"):
			if form["pathXML"].value != '':
				if form["pathXML"].filename[-3:] != 'xml' and form["pathXML"].filename[-3:] != 'XML':
					self.error.append(1)				# ERROR: el archivo que está intentado importar no tiene la extensión adecuada
				else:				
					if form["pathXML"].value[:49] != """<?xml version="1.0" encoding="UTF-8"?>\n<requests>""":
						self.error.append(2)			# ERROR: el contenido del archivo XML no se corresponde al formato requerido
					else:
						self.contXML = form["pathXML"].file.read()	# ÉXITO: capturamos el contenido del archivo XML
			else:
				self.error.append(3)					# ERROR grave
		else:
			self.error.append(4)						# ERROR crítico


	def gestErrores (self):
		""" Devuelve una cadena enumerando los errores detectados en el formulario.
		"""
		msg = ""
		if len(self.error) != 0:
			msg += """<br/>Este mensaje de error ha sido generado por el servidor de la aplicación.
<br/>A continuación se muestran los fallos detectados:<br/> 
"""
			for i in self.error:
				if i==1:
					msg += """<br/>ERROR (01IP): El archivo que está intentando importar no tiene la extensión 'xml' requerida. \n"""
				if i==2:
					msg += """<br/>ERROR (02IP): El contenido del archivo no posee el formato adecuado. \n"""
				if i==3:
					msg += """<br/>ERROR (03IP): Debe rellenar el campo: "Archivo XML". \n"""
				if i==4:
					msg += """<br/>ERROR (04IP): Error crítico!! Este error se debe a una modificación de las fuentes. \n"""
		return msg


	def htmlAfterImport(self):
		"""
		"""
		contenidoHtml = unicode ("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="express" content="-1">
	<meta http-equiv="Expires: Wed, 05 Nov 2003 16:46:04 GMT">
	<meta http-equiv="Last-Modified:Tue, 12 May 1998 22:18:49 GMT">
	<meta http-equiv="Cache-Control" content="no-cache, mustrevalidate">
	<meta http-equiv="Pragma" content="no-cache">
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Sistema de Creación y Gestión de Autoridades de Certificación</title>
	<link rel="stylesheet" type="text/css" href="../web/estiloInd.css" media="all">
	<link rel="shortcut icon" href="../web/favicon.ico">
	<script type="text/javascript" src="../web/view.js"></script>
</head>
<body id="main_body">
	<img id="top" src="../web/images/top.png" alt="">	
	<img src="../web/images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../web/index.html" /></map>
	<div id="contenedor">
		<br />
		<form id="form_39443" class="appnitro">
		<div class="form_description">
			<h2>Peticiones Importadas con Éxito.</h2>
			<p>A continuación dispone de la lista de peticiones recién importadas.</p>
		</div>
		<ul>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
			<tbody>
			<tr>
				<td><div align="left"><a href="../web/index.html"><img src="../web/images/icons/house.png" width="16" height="16" /> Volver a Inicio</a></div></td>
				<td><div align="right"><a href="../web/tratReq.html">Ir a Lista de Peticiones Pendientes <img src="../web/images/icons/table_edit.png" width="16" height="16" /></a></div></td>
				</tr>
			</tbody>
			</table>
		<div class="section_break"></div>""", 'utf-8')
		xmlReqObj = _xml.XMLReq()

		xmldoc = minidom.parseString(self.contXML)

		tuplaListas = xmlReqObj.parseoXML(xmldoc)
		l = len(tuplaListas[0])
		if l > 0:
			contenidoHtml = contenidoHtml + unicode("""\n\t\t<li>
		<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
		<tbody>
		<tr>
			<td><div><strong>Fecha de Importación:</strong> """ + time.ctime() + """</div></td>
		</tr>""", 'utf-8')
		while l > 0:
			contenidoHtml = contenidoHtml + unicode("""\n\t\t<tr>
			<td width="48%" class="preview"><div align="center"><strong>id de la Petición:</strong> """ + str(tuplaListas[0][l-1].encode('utf-8')) + """ - <strong>id del Cliente:</strong> """ + str(tuplaListas[1][l-1].encode('utf-8')) + """</div></td>
		</tr>""", 'utf-8')
			l = l-1
		if len(tuplaListas[0]) > 0:
			contenidoHtml = contenidoHtml + unicode("""\n\t\t</li>
		<div class="section_break"></div>
		</ul>""", 'utf-8')
		# Pie de página, siempre se mostrará incluso si no hay CAs.
		contenidoHtml = contenidoHtml + unicode ("""\n\t\t\t
		</form>
	<div id="footer">
		<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
	</div>
	</div>
	<img id="bottom" src="../web/images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
		print contenidoHtml.encode('utf-8')



def actualizaTratReqHtml(tuplaListas):
	""" Actualiza el archivo tratReq.html que contendrá en cada momento una 
		tabla que mapea el contenido de requests/requests.xml 
	"""
	contenidoHtml = unicode ("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="express" content="-1">
	<meta http-equiv="Expires: Wed, 05 Nov 2003 16:46:04 GMT">
	<meta http-equiv="Last-Modified:Tue, 12 May 1998 22:18:49 GMT">
	<meta http-equiv="Cache-Control" content="no-cache, mustrevalidate">
	<meta http-equiv="Pragma" content="no-cache">
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Sistema de Creación y Gestión de Autoridades de Certificación</title>
	<link rel="stylesheet" type="text/css" href="estiloInd.css" media="all">
	<link rel="shortcut icon" href="./favicon.ico">
	<script type="text/javascript" src="view.js"></script>
</head>
<body id="main_body">
	<img id="top" src="images/top.png" alt="">	
	<img src="./images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="index.html" /></map>
	<div id="contenedor">
		<br />
		<form id="form_39443" class="appnitro">""", 'utf-8')
	num = len(tuplaListas[0])

	if num == 0:
	# no hay peticiones importadas
		contenidoHtml = contenidoHtml + unicode ("""\n\t\t<ul>
		<div class="form_description">
			<h2>Peticiones Pendientes de Tratamiento.</h2>
			<p>Actualmente no existen peticiones no tratadas en el sistema.</p>""", 'utf-8')

	else:
		# Cabecera de las tablas conteniendo la info
		contenidoHtml = contenidoHtml + unicode ("""\n\t\t<ul>
		<div class="form_description">
			<h2>Peticiones Pendientes de Tratamiento.</h2>
			<p>A continuación dispone de una lista con todos aquellas peticiones importadas que se mantienen en espera de ser atendidas.</p>
		</div>""", 'utf-8')
		while num > 0:
			# Estructura html de cada tabla correspondiente a las peticiones importadas cada vez.
				tablaHtml = unicode ("""\n\t\t\t<li>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
				<tbody>
				<tr>
					<td><div><strong>Fecha de Importación:</strong>""" + + """</div></td>
				</tr>
			</li>
			<div class="section_break"></div>""", 'utf-8')
				contenidoHtml += tablaHtml
				num = num-1

# Pie de página, siempre se mostrará incluso si no hay peticiones pendientes.
	contenidoHtml = contenidoHtml + unicode ("""\n\t\t\t</ul>
		</form>
	<div id="footer">
		<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
	</div>
	</div>
	<img id="bottom" src="images/bottom.png" alt="">
</body>
</html>""", 'utf-8')

	f = open (dirAct + '/tratReq.html', 'w')
	f.write(contenidoHtml.encode('utf-8'))
	f.close()



if __name__ == '__main__':
	print "Content-Type: text/html"     			# sigue HTML
	print											# linea en blanco, fin de la cabecera
	cf = CFormulario()
	cadErrores = cf.gestErrores()
	if len(cadErrores) == 0:
		# llevar a cabo el proceso de importación
		objXmlReq = _xml.XMLReq()
		objXmlReq.importar(cf)

#		dirAct = os.getcwd()
#		pathReq = dirAct + '/requests/requests.xml'
#		xmldoc = minidom.parse(pathReq)				# parsea el archivo requests/requests.xml

#		tuplaListas = objXmlReq.parseoXML(xmldoc)
#		actualizaTratReqHtml(tuplaListas)

		cf.htmlAfterImport()
	else:
		print cadErrores

