#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

import time

# Funciones que trabajan con cadenas
def listaToCadena (lista):
	""" Toma una lista de cadenas y la convierte en una sola cadena con los 
		elementos separados por comas.
	"""
	cadena = ""
	x = 0
	while x<(len(lista)-1):
		cadena = cadena + lista[x] + ','
		x = x+1
	cadena = cadena + lista[len(lista)-1]
	return cadena


# Funciones que trabajan con fechas
def compFecha (f1, f2):
	""" Compara fechas, devolviento un Logico con valor True si la fecha f1 es 
		anterior a f2 o False si es al contrario o son iguales.

		El formato de las fechas pasadas como parámetros es: DD-MM-AAAA
	"""
	dia1 = f1[:2]
	dia2 = f2[:2]
	mes1 = f1[3:5]
	mes2 = f2[3:5]
	anyo1 = f1[6:]
	anyo2 = f2[6:]

	res = True
	if anyo2 > anyo1:
		res = True
	elif anyo2 < anyo1:
		res = False
	else:		
		if mes2 > mes1:
			res = True
		elif mes2 < mes1:
			res = False
		else:
			if dia2 > dia1:
				res = True
			else:
				res = False
	return res


def fechaActCad ():
	""" Crea una cadena con la fecha actual GMT con el siguiente formato:
		"dd-mm-aaaa"
	"""
	fechaActTupla = time.gmtime()
	dia = str(fechaActTupla.tm_mday)
	if len(dia) == 1:
		dia = '0' + dia
	mes = str(fechaActTupla.tm_mon)
	if len(mes) == 1:
		mes = '0' + mes
	anyo = str(fechaActTupla.tm_year)
	fechaActString = dia + '-' + mes + '-' + anyo
	return fechaActString


def posFechaAct (dia, mes, anyo):
	""" Nos dice si la fecha pasada en los argumentos es POSTERIOR a la fecha actual.

		@param1type: entero
		@param2type: entero
		@param3type: entero
		@rtype: logico (boolean)
		@return: False/True
	"""
	res = True
	tupTime = time.localtime()
	if anyo > tupTime.tm_year:
		res = True
	elif anyo < tupTime.tm_year:
		res = False
	else:		
		if mes > tupTime.tm_mon:
			res = True
		elif mes < tupTime.tm_mon:
			res = False
		else:
			if dia > tupTime.tm_mday:
				res = True
			else:
				res = False
	return res


def posFechaHoraAct (dia, mes, anyo, hora, minuto, segundo):
	""" Nos dice si la fecha y hora pasada en los argumentos es POSTERIOR a la 
		fecha y hora GMT actual.

		@param1type: entero
		@param2type: entero
		@param3type: entero
		@param4type: entero
		@param5type: entero
		@param6type: entero
		@rtype: logico (boolean)
		@return: False/True
	"""
	res = True
	tupTime = time.gmtime()
	if anyo > tupTime.tm_year:
		res = True
	elif anyo < tupTime.tm_year:
		res = False
	else:		
		if mes > tupTime.tm_mon:
			res = True
		elif mes < tupTime.tm_mon:
			res = False
		else:
			if dia > tupTime.tm_mday:
				res = True
			elif dia < tupTime.tm_mday:
				res = False
			else:
				if hora > tupTime.tm_hour:
					res = True
				elif hora < tupTime.tm_hour:
					res = False
				else:
					if minuto > tupTime.tm_min:
						res = True
					elif hora < tupTime.tm_min:
						res = False
					else:
						if segundo > tupTime.tm_sec:
							res = True
						else:
							res = False
	return res

# Otras
def copiarArchivo (original, copia):
	""" Copia el archivo pasado como primer parámetro en la localización pasada 
		como segundo.

		@param1type: string
		@param2type: string
		@rtype: logico (boolean)
		@return: False/True
	"""
	arcOrig = open (original, 'r')
	arcCopia = open (copia, 'w')
	arcCopia.write(arcOrig.read())
	arcOrig.close()
	arcCopia.close()


def contieneEspacios (cadena):
	"""Comprueba si una cadena contiene espacios.

       @type cadena: string
       @param cadena: cadena a analizar 

       @rtype: Boolean
       @return: True/False
    """
	contiene = False
	for x in cadena:
		if x.isspace():
			contiene = True
	return contiene
