#!/usr/local/bin/python
# -*- coding: iso-8859-1 -*-

import CGIHTTPServer
import os
import cgi
from xml.dom import minidom
import urllib
import time
from M2Crypto import X509
from types import *

class AJAXHTTPRequestHandler (CGIHTTPServer.CGIHTTPRequestHandler):
	"""
	Manejador que responde a peticiones HTTP.
	"""

	def do_GET(self):
		"""
		Gestión los GET.
		"""		
		if self.path[-10:] == "index.html":				# EventoIndex: acceso a .../web/index.html
			self.gestionEventoIndex()
		elif self.path[-14:] == "gestCerts.html":		# EventoGestCerts: acceso a .../web/CAs/" + idCA + "/gestCert.html
			self.gestionEventoGestCerts()
		elif self.path[-8:] == "crl.html":				# EventoCrl: acceso a .../web/CAs/" + idCA + "/crl.html
			self.gestionEventoCrl()
		elif self.path[-10:] == "ioReq.html":			# EventoIOReq: acceso a .../web/ioReq.html
			self.gestionEventoIOReq()
		elif self.path[-12:] == "tratReq.html":			# EventoCrl: acceso a .../web/tratReq.html
			self.gestionEventotratReq()
		elif self.path[-9:] == "_req.html":				# EventoIDreq: acceso a .../web/requests/id_ID_req.html
			pos1 = self.path.find("id_")
			pos2 = self.path.find("_req.html")
			idRequest = self.path[pos1+3:pos2]
			self.gestionEventoIDReq(idRequest)

		# EventoBusq: uso de la búsqueda de certificados por número de serie, 
		# es decir acceso a /web/CAs/" + idCA + "/gestCert.html?idCA=X&serial=Y
		# Para comprobar que se trata de la busqueda rápida vamos a comprobar  
		# que justo antes del '?' en el path viene gestCerts.html
		pos = self.path.find('?')
		l = len(self.path)
		if self.path[(pos - l -14):(pos - l)] == "gestCerts.html":		# EventoBusq: Pulsado del botón Buscar en /web/CAs/" + idCA + "/gestCert.html
			self.gestionEventoBusq()

		# EventoBusqPet: uso de la búsqueda de peticiones por número de serie, 
		# es decir acceso a /web/ioReq.html?nSReq=X
		# Para comprobar que se trata de la busqueda rápida vamos a comprobar  
		# que justo antes del '?' en el path viene ioReq.html
		if self.path[(pos - l -10):(pos - l)] == "ioReq.html":			# EventoBusq: Pulsado del botón Buscar en /web/ioReq.html
			self.gestionEventoBusqReq()
		else:
			if (self.path[-3:]  == ".js" or self.path[-4:]  == ".css"):	# Evento: se accede a un archivo '.js' o '.css'
				self.envia_fichero("",self.path[1:])
			else:														# Evento: se accede a otro tipo de archivo no contemplado
				self.envia_fichero(os.getcwd(), self.path)


	def gestionEventoIDReq(self, idRequest):
		""" 
		Respuesta a EventoIDReq: Genera la página html id_ID_req.html
		conteniendo la petición con id ID.
		"""		
		listaDatos = self.parseoCompReqXML(idRequest)				# obtenemos la lista de datos de la petición con id idRequest
		listaCAsPosibles = self.parseoCAsPosXML(listaDatos[17])		# obtenemos lista de CAs que pueden firmar esa petición
		self.generaIDReqHtml(listaDatos, listaCAsPosibles)			# generamos el html


	def generaIDReqHtml (self, listaDatos, listaCAs):
		""" 
		Genera el código HTML de la página idReq.html cuyos valores son 
		los contenidos en el primer argumento.
		"""
		# Generación del código a incrustar en el html
		htmlElement = ""
		for elem in listaCAs:
			htmlElement += "\n\t\t\t\t<option>" + elem + "</option>"

		# Tratamiento del valor codificado en el XML del uso del certificado
		if listaDatos[16] == '1':
			usoString = "S/MIME"
		elif listaDatos[16] == '2':
			usoString = "Cifrado"
		elif listaDatos[16] == '3':
			usoString = "Cliente SSL"
		elif listaDatos[16] == '4':
			usoString = "Servidor SSL"
		elif listaDatos[16] == '5':
			usoString = "Certificado de CA"
		else:
			usoString = "Firma Código/Objeto"

		# Creación del código HTML
		htmlCode1 = unicode ("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>Petición de Certificado Digital número """ + str(listaDatos[0].encode('utf-8')) + """</title>
	<link rel="stylesheet" type="text/css" href="../estiloInd.css" media="all">
	<script type="text/javascript">
		function mostrar(enla) {
		  obj = document.getElementById('oculto');
		  obj.style.visibility = (obj.style.visibility == 'hidden') ? 'visible' : 'hidden';
		  enla.innerHTML = (enla.innerHTML == 'Ocultar Password') ? 'Mostrar Password' : 'Ocultar Password';
		}
	</script>
</head>
<body id="main_body" >
	<img id="top" src="../images/top.png" alt="">
	<img src="../images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../index.html" /></map>
	<div id="contenedor">
		<br>
		<form id="form_43076" class="appnitro"  method="post" action="http://localhost:8000/cgi-bin/crearNuevoCert.py">
		<div class="form_description">""", 'utf-8')

		# Título según estado
		if listaDatos[19] == "aceptada":
			htmlCode1 += unicode ("""\n\t\t\t<h2>Petición número: """ + str(listaDatos[0].encode('utf-8')) + """ ( <a href='../CAs/""" + str(listaDatos[20].encode('utf-8')) + """/certs/""" + str(listaDatos[21].encode('utf-8')) + """.html'>Aceptada</a> )</h2>""", 'utf-8')
		elif listaDatos[19] == "rechazada":
			htmlCode1 += unicode ("""\n\t\t\t<h2>Petición número: """ + str(listaDatos[0].encode('utf-8')) + """ ( Rechazada )</h2>""", 'utf-8')
		elif listaDatos[19] == "espera":
			htmlCode1 += unicode ("""\n\t\t\t<h2>Petición número: """ + str(listaDatos[0].encode('utf-8')) + """ ( Pendiente de Tratamiento )</h2>""", 'utf-8')

		htmlCode1 += unicode("""\n\t\t\t<p>A continuación se encuentra la información que ha ingresado el cliente en el formulario para solicitar un certificado digital, al fondo dispone de la opciones que le permiten aceptar o rechazar la petición.</p>
			<ul>
				<input type=hidden id="idReq" name="idReq" class="element text medium" type="text" maxlength="255" value='""" + str(listaDatos[0].encode('utf-8')) + """'/>

			<div class="section_break">
				<h3>Identificación del Peticionario.</h3>
				<p>Datos de la persona física o jurídica que deberá de demostrar propios mediante su documentación a efectos de cotejación a la hora de recoger el certificado.</p>
			</div>
			<li id="li_1" >
				<label class="description" for="identificacion">Número o Código de Identificación Fiscal: </label>
				<div>
					""" + str(listaDatos[1].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_22" >
				<label class="description" for="codigo">Código de Seguridad: </label>
				<div>
					<input type=hidden id="codigo" name="codigo" class="element text medium" type="text" maxlength="255" value='""" + str(listaDatos[18].encode('utf-8')) + """'/>
					""" + str(listaDatos[18].encode('utf-8')) + """
				</div>
			</li>
			<div class="section_break">
				<h3>Información del Titular.</h3>
				<p>Información de la persona, organización o empresa que será titular del certificado, esta información formará parte del propio certificado y tendrán acceso a ella los usuarios del mismo.</p>
			</div>
			<li id="li_2" >
				<label class="description" for="comName">Nombre Común (CN): </label>
				<div>
					<input type=hidden id="comName" name="comName" class="element text medium" type="text" maxlength="255" value='""" + str(listaDatos[2].encode('utf-8')) + """'/>
					""" + str(listaDatos[2].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_3" >
				<label class="description" for="surname">Apellido (SN): </label>
				<div>
					<input type=hidden id="surname" name="surname" class="element text medium" type="text" maxlength="255" value='""" + str(listaDatos[3].encode('utf-8')) + """'/> 
					""" + str(listaDatos[3].encode('utf-8')) + """
				</div>
			</li>""", 'utf-8')
		htmlCode2 = unicode ("""<li id="li_4" >
				<label class="description" for="givName">Sobrenombre (GN): </label>
				<div>
					<input type=hidden id="givName" name="givName" class="element text medium" type="text" maxlength="255" value='""" + str(listaDatos[4].encode('utf-8')) + """'/>
					""" + str(listaDatos[4].encode('utf-8')) + """
				</div>
			</li>""", 'utf-8')
		htmlCode3 = unicode ("""<li id="li_5" >
				<label class="description" for="serial">Número de Serie: </label>
				<div>
					<input type=hidden id="serial" name="serial" class="element text medium" type="text" maxlength="255" value='""" + str(listaDatos[8].encode('utf-8')) + """'/>
					""" + str(listaDatos[8].encode('utf-8')) + """
				</div>
			</li>""", 'utf-8')
		htmlCode4 = unicode("""<li id="li_6" >
				<label class="description" for="org">Organización (O): </label>
				<div>
					<input type=hidden id="org" name="org" class="element text large" type="text" maxlength="255" value='""" + str(listaDatos[5].encode('utf-8')) + """'/>
					""" + str(listaDatos[5].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_7" >
				<label class="description" for="uniOrg">Unidad Organizativa (OU): </label>
				<div>
					<input type=hidden id="uniOrg" name="uniOrg" class="element text large" type="text" maxlength="255" value='""" + str(listaDatos[6].encode('utf-8')) + """'/>
					""" + str(listaDatos[6].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_8" >
				<label class="description" for="emaCont">Email: </label>
				<div>
					<input type=hidden id="emaCont" name="emaCont" class="element text large" type="text" maxlength="255" value='""" + str(listaDatos[7].encode('utf-8')) + """'/>
					""" + str(listaDatos[7].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_9" >
				<label class="description" for="ciudad">Ciudad: </label>
				<div>
					<input type=hidden id="ciudad" name="ciudad" class="element text medium" value='""" + str(listaDatos[9].encode('utf-8')) + """' type="text"/>
					""" + str(listaDatos[9].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_10" >
				<label class="description" for="provincia">Provincia: </label>
				<div>
					<input type=hidden id="provincia" name="provincia" class="element text medium" value='""" + str(listaDatos[10].encode('utf-8')) + """' type="text"/>
					""" + str(listaDatos[10].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_11" >
				<label class="description" for="pais">País: </label>
				<div>
					<input type=hidden id="pais" name="pais" class="element text medium" value='""" + str(listaDatos[11].encode('utf-8')) + """' type="text"/>
					""" + str(listaDatos[11].encode('utf-8')) + """
				</div>
			</li>
			<div class="section_break">
				<h3>Uso del Certificado.</h3>
				<p>	Usos para los cuales será utilizado el certificado digital.</p>
			</div>
			<li id="li_16" >
				<label class="description" for="pais">Uso del certificado: </label>
				<div>
					<input type=hidden id="uso" name="uso" class="element text medium" type="text" maxlength="255" value='""" + str(listaDatos[16].encode('utf-8')) + """'/>
					""" + str(usoString.encode('utf-8')) + """
				</div>
			</li>
			<div class="section_break">
				<h3>Claves Pública y Privada.</h3>
				<p>Datos necesarios para generar el par de claves RSA asociadas al Certificado Digital.</p>
			</div>
			<li id="li_17" >
				<label class="description" for="numBits">Número de bits de la Clave Privada: </label>
				<div>
					<input type=hidden id="numBits" name="numBits" class="element text small" type="text" maxlength="255" value='""" + str(listaDatos[12].encode('utf-8')) + """'/>
					""" + str(listaDatos[12].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_18" >
				<label class="description" for="exp">Exponente: </label>
				<div>
					<input type=hidden id="exp" name="exp" class="element text small" type="text" maxlength="255" value='""" + str(listaDatos[13].encode('utf-8')) + """'/>
					""" + str(listaDatos[13].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_19" >
				<input type=hidden id="password" name="password" class="element text large" type="password" maxlength="255" value='""" + str(listaDatos[14].encode('utf-8')) + """'/>
				<label class="description" for="password">Password: </label>
				Por razones de seguridad el password se mantiene oculto por defecto, si desea verlo pulse sobre el siguiente enlace: <a href="#" onclick="mostrar(this); return false" />Mostrar Password</a>.
				<div id="oculto" style="visibility:hidden">
					Password: """ + str(listaDatos[14].encode('utf-8')) + """
				</div>
			</li>
			<li id="li_20">
				<label class="description" for="firma">Algoritmo de Firma: </label>
				<div>
					<input type=hidden id="firma" name="firma" class="element text large" type="firma" maxlength="255" value='""" + str(listaDatos[15].encode('utf-8')) + """'/>
					""" + str(listaDatos[15].encode('utf-8')) + """
				</div>
			</li>
			<div class="section_break">
				<h3>Validez del Certificado</h3>
				<p>El certificado será válido a partir del momento de emisión hasta la fecha que elija a continuación.</p>
			</div>		
			<li id="li_21" >
				<label class="description" for="fechaCaduc">Fecha de Caducidad: </label>
				<div>
					<span>
						<input type=hidden id="fechaCaduc_1" name="fechaCaduc_1" class="element text" size="2" maxlength="2" value='""" + str(listaDatos[17][0:2].encode('utf-8')) + """' type="text"/>
					</span>
					<span>
						<input type=hidden id="fechaCaduc_2" name="fechaCaduc_2" class="element text" size="2" maxlength="2" value='""" + str(listaDatos[17][3:5].encode('utf-8')) + """' type="text"/>

					</span>
					<span>
				 		<input type=hidden id="fechaCaduc_3" name="fechaCaduc_3" class="element text" size="4" maxlength="4" value='""" + str(listaDatos[17][6:10].encode('utf-8')) + """' type="text"/>
					</span>
					""" + str(listaDatos[17].encode('utf-8')) + """
				</div>
			</li>""", 'utf-8')
		htmlCode5 = unicode("""<div class="section_break">
				<h3>Tratamiento de la Petición</h3>
				<p>El tratamiento de la petición se reduce a dos posibilidades, emitir el certificado digital peticionado o rechazar la petición, en el primer caso elija a continuación la Autoridad de Certificación con la que desee firmar el certificado.</p>
			</div>	
			<li id="li_23" >
				<label class="description" for="cas">Autoridad de Certificación emisora: </label>
				<div>
					<select id="idCA" name="idCA">""" + str(htmlElement.encode('utf-8')) + """
					</select>
				</div>
			</li>""", 'utf-8')
		htmlCode6 = unicode("""<div class="section_break">
				<h3>Tratamiento de la Petición</h3>
				<p>Actualmente no existe en el sistema ninguna Autoridad de Certificación que pueda generar un certificado digital con las características indicadas en esta petición.</p>
				<p>Este problema puede deberse a que no disponga de ninguna Autoridad de Certificación en activo en estos momentos (icono verde), o de las que dispone todas tienen una fecha de caducidad anterior a la requerida en esta petición.</p>
				<p>Si desea completar la petición vuelva a la <a href="../index.html">página de inicio</a> y cree una nueva Autoridad de Certificación cuya fecha de caducidad sea posterior al """ + str(listaDatos[17].encode('utf-8')) + """.
			</div>""", 'utf-8')
		htmlCode7 = unicode("""<div align="center" class="buttons">
				<input type="hidden" name="form_id" value="43076" />""", 'utf-8')
		htmlCode8 = unicode("""<input id="acepPet" name="acepPet" class="button_text" type="submit" name="submit" value="Crear Certificado" />""", 'utf-8')
		htmlCode9 = unicode("""<input id="rechPet" name="rechPet" class="button_text" type="submit" name="submit" value="Rechazar Petición" />
			</div>
		</div>
		</ul>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
		htmlCode10 = unicode("""</div>
		</ul>
		</form>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
		htmlCode = htmlCode1
		if listaDatos[4] != '':
			htmlCode = htmlCode + htmlCode2
		if listaDatos[5] != '':
			htmlCode = htmlCode + htmlCode3
		htmlCode += htmlCode4


		if listaDatos[19] == 'espera':
			if len(listaCAs) != 0:
				htmlCode += htmlCode5
			else:
				htmlCode += htmlCode6
			htmlCode += htmlCode7
			if len(listaCAs) != 0:
				htmlCode += htmlCode8
			htmlCode += htmlCode9
		else:
			htmlCode += htmlCode10



#		if len(listaCAs) != 0:
#			htmlCode += htmlCode5
#		else:
#			htmlCode += htmlCode6
#		htmlCode += htmlCode7
#		if len(listaCAs) != 0:
#			htmlCode += htmlCode8
#		htmlCode += htmlCode9
		dirAct = os.getcwd()
		f = open (dirAct + '/web/requests/id_' + listaDatos[0] + '_req.html', 'w')
		f.write(htmlCode.encode('utf-8'))
		f.close()



	def parseoCAsPosXML (self, fechaCad):
		""" Realiza un parsea del documento /web/CAs/CAs.xml y devuelve una 
			lista con los idCAs de aquellas CAs cuyo <estado> sea 'valido' 
			y cuya <fechaRev> sea anterior a la indicada en el argumento fechaCad
		"""
		dirAct = os.getcwd()
		pathXml = dirAct + '/web/CAs/CAs.xml'
		listaCAs = []
		if os.access(pathXml, os.F_OK):
			xmldoc = minidom.parse(pathXml)
			CALista = xmldoc.getElementsByTagName('ca')
			l = len(CALista)
			while l>0:
				if CALista[l-1].getElementsByTagName('estado').item(0).firstChild.data == 'valido' and compFechas (fechaCad, CALista[l-1].getElementsByTagName('fechaRev').item(0).firstChild.data):
					listaCAs.append(CALista[l-1].attributes['id'].value)
				l = l-1
		return listaCAs



	def parseoCompReqXML(self, idRequest):
		""" Devuelve la información de la petición en una lista.
		"""
		dirAct = os.getcwd()
		pathReqXml = dirAct + '/requests/requests.xml'
		if os.path.exists(pathReqXml):
			xmldoc = minidom.parse(pathReqXml)
			reqLista = xmldoc.getElementsByTagName('request')
			l = len(reqLista)
			encontrado = False
			while l>0 and not encontrado:
				if reqLista[l-1].attributes["id"].value == idRequest:
					encontrado = True
					idDocument = reqLista[l-1].getElementsByTagName('idDocument').item(0).firstChild.data
					cn = reqLista[l-1].getElementsByTagName('cn').item(0).firstChild.data
					sn = reqLista[l-1].getElementsByTagName('sn').item(0).firstChild.data
					o = reqLista[l-1].getElementsByTagName('o').item(0).firstChild.data
					ou = reqLista[l-1].getElementsByTagName('ou').item(0).firstChild.data
					email = reqLista[l-1].getElementsByTagName('email').item(0).firstChild.data
					loc =  reqLista[l-1].getElementsByTagName('loc').item(0).firstChild.data
					st = reqLista[l-1].getElementsByTagName('st').item(0).firstChild.data
					pais = reqLista[l-1].getElementsByTagName('pais').item(0).firstChild.data
					numBits = reqLista[l-1].getElementsByTagName('numBits').item(0).firstChild.data
					exponente = reqLista[l-1].getElementsByTagName('exponente').item(0).firstChild.data
					password = reqLista[l-1].getElementsByTagName('password').item(0).firstChild.data
					algFirma = reqLista[l-1].getElementsByTagName('algFirma').item(0).firstChild.data
					uso = reqLista[l-1].getElementsByTagName('uso').item(0).firstChild.data
					fechaCad = reqLista[l-1].getElementsByTagName('fechaCad').item(0).firstChild.data
					codigo = reqLista[l-1].getElementsByTagName('codigo').item(0).firstChild.data
					estado = reqLista[l-1].getElementsByTagName('estado').item(0).firstChild.data
					# El peticionario puede dejar en blanco los campos "Given Name" y "Serial"
					if not type(reqLista[l-1].getElementsByTagName('gn').item(0).firstChild) is NoneType:
						gn = reqLista[l-1].getElementsByTagName('gn').item(0).firstChild.data
					else:
						gn = ''
					if not type(reqLista[l-1].getElementsByTagName('serial').item(0).firstChild) is NoneType:
						serial = reqLista[l-1].getElementsByTagName('serial').item(0).firstChild.data
					else:
						serial = ''
				l = l-1
			# código para generar el enlace al certificado
			idCA = ""
			sNCert = ""
			if estado == "aceptada":
				idCA = reqLista[l].attributes["idCA"].value
				sNCert = reqLista[l].attributes["sNCert"].value
		return [idRequest, idDocument, cn, sn, gn, o, ou, email, serial, loc, st, pais, numBits, exponente, password, algFirma, uso, fechaCad, codigo, estado, idCA, sNCert]



	def gestionEventoIOReq(self):
		""" Respuesta a EventoIOReq: Genera la página html ioReq.html 
		conteniendo dos partes, en la primera un form con un campo para importar 
		el xml con las peticiones y en la segunda una zona de búsqueda de 
		peticiones por identificador.
		"""

# TODO parte correspondiente a la búsqueda por número de id de la request
		dirAct = os.getcwd()
		rutaReqXML = dirAct + "/requests/requests.xml"
		lista = []
		if os.path.exists (rutaReqXML):
			xmldoc = minidom.parse(rutaReqXML)
			# lista conteniendo el atributo 'id' y los valores de las etiquetas 
			# <idDocument>, <codigo> y <estado> de la última petición importada
			lista = self.parseoUltReqXML(xmldoc)
		self.generaIOReqHtml(lista)
#		self.generaIOReqHtml()



	def parseoUltReqXML (self, xmldoc = None):
		listaDatos = []
		if xmldoc != None:
			reqLista = xmldoc.getElementsByTagName('request')
			l = len(reqLista)
			idReq = ""
			idDocument = ""
			codigo = ""
			estado = ""
			if l != 0:
				idReq = reqLista[l-1].attributes["id"].value
				idDocument = reqLista[l-1].getElementsByTagName('idDocument').item(0).firstChild.data
				codigo = reqLista[l-1].getElementsByTagName('codigo').item(0).firstChild.data
				estado = reqLista[l-1].getElementsByTagName('estado').item(0).firstChild.data
		listaDatos.append(idReq)
		listaDatos.append(idDocument)
		listaDatos.append(codigo)
		listaDatos.append(estado)
		return listaDatos






	def gestionEventotratReq(self):
		""" Respuesta a EventotratReq: Genera la página html tratReq.html 
		conteniendo una tabla con las peticiones no tratadas actualmente en el 
		sistema.
		"""
# TODO parte correspondiente a la búsqueda por número de id de la request
#		dirAct = os.getcwd()
#		rutaReqXML = dirAct + "/web/revocados.xml"
#		tuplaListas = None
#		if os.path.exists (rutaReqXML):
#			xmldoc = minidom.parse(rutaReqXML)
#			tuplaListas = self.parseoReqXML(xmldoc)
#		self.generaIOReqHtml(tuplaListas)
		dirAct = os.getcwd()
		pathReq = dirAct + '/requests/requests.xml'
		xmldoc = minidom.parse(pathReq)		# parsea el archivo requests/requests.xml
		tuplaListas = self.parseoReqXML(xmldoc)
		self.generaTratReqHtml(tuplaListas)


	def generaTratReqHtml(self, tuplaListas):
		""" Método que genera la página /web/tratReq.html a partir de con la 
			lista de peticiones pendientes de tratamiento de /requests/requests.xml
		"""
		# Creación del código html
		contenidoHtml = unicode ("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Sistema de Creación y Gestión de Autoridades de Certificación</title>
	<link rel="stylesheet" type="text/css" href="estiloInd.css" media="all">
	<link rel="shortcut icon" href="./favicon.ico">
	<script type="text/javascript" src="view.js"></script>
</head>
<body id="main_body">
	<img id="top" src="images/top.png" alt="">	
	<img src="./images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="index.html" /></map>
	<div id="contenedor">
		<br />
		<form id="form_39443" class="appnitro">""", 'utf-8')
		contenidoHtml = contenidoHtml + unicode("""\n\t\t<div class="form_description">
			<h2>Lista de Peticiones Pendientes de Tratamiento.</h2>
			<p>La siguiente lista contiene todas las peticiones importadas y que aún no han sido tratadas. Para su tratamiento pulse sobre aquella que desee gestionar.</p>
		</div>""", 'utf-8')
		l = len(tuplaListas[0])
		fechaImp = ''
		if l == 0:
			contenidoHtml = contenidoHtml + unicode("""\n\t\t<li>
			<p align="center">No existen actualmente peticiones pendientes de tratamiento.</p></li>""", 'utf-8')
		else:
			while l > 0:
				if (fechaImp != str(tuplaListas[0][l-1].encode('utf-8'))):
					fechaImp = str(tuplaListas[0][l-1].encode('utf-8'))

					if l == len(tuplaListas[0]):
						contenidoHtml = contenidoHtml + unicode("""\n\t\t<li>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
			<tbody>
			<tr>
				<td><div><img src="./images/icons/date.png"><strong> Fecha de Importación:</strong> """ + fechaImp + """</div></td>
			</tr>""", 'utf-8')

					else:
						contenidoHtml = contenidoHtml + unicode("""\n\t\t</table>
			</li>
			<div class="section_break"></div>
			<li>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
			<tbody>
			<tr>
				<td><div><img src="./images/icons/date.png"><strong> Fecha de Importación:</strong> """ + fechaImp + """</div></td>
			</tr>""", 'utf-8')			

				contenidoHtml = contenidoHtml + unicode("""\n\t\t<tr>
			<td width="48%" class="preview"><div align="center"><a href='./requests/id_""" + str(tuplaListas[1][l-1].encode('utf-8')) + """_req.html'><img src="./images/icons/table_go.png"><strong> id de la Petición:</strong> """ + str(tuplaListas[1][l-1].encode('utf-8')) + """ - <strong>id del Cliente:</strong> """ + str(tuplaListas[2][l-1].encode('utf-8')) + """</a></div></td>
		</tr>""", 'utf-8')
				l = l-1

		if len(tuplaListas[0]) > 0:
			contenidoHtml = contenidoHtml + unicode("""\n\t\t</li>""", 'utf-8')
		# Pie de página, siempre se mostrará incluso si no hay CAs.
		contenidoHtml = contenidoHtml + unicode ("""\n\t\t\t<div class="section_break"></div>
		</form>
	<div id="footer">
		<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
	</div>
	</div>
	<img id="bottom" src="images/bottom.png" alt="">
</body>
</html>""", 'utf-8')

		dirAct = os.getcwd()
		f = open (dirAct + '/web/tratReq.html', 'w')
		f.write(contenidoHtml.encode('utf-8'))
		f.close()


	def parseoReqXML (self, xmldoc = None):
		""" Realiza un análisis del argumento 'xmldoc' 
		para obtener los valores del atributo 'id' y de las etiquetas 
		<idDocument> y <codigo> de todas las peticiones cuya etiqueta <estado> 
		sea 'espera' de las creadas con la RA.

		Devuelve una tupla de listas.
		"""

		# Obteniendo los valores de '/web/CAs/CAs.xml'
		importDate = []
		idReq = []		# se refiere a la etiqueta <id>, pero id es palabra reservada de Python
		idDocument = []
		if xmldoc != None:
			reqLista = xmldoc.getElementsByTagName('request')
			l = len(reqLista)
			i = 0
			while i < l:
				if reqLista[i].getElementsByTagName('estado').item(0).firstChild.data == 'espera':
					importDate.append (reqLista[i].attributes["importDate"].value)
					idReq.append (reqLista[i].attributes["id"].value)
					idDocument.append (reqLista[i].getElementsByTagName('idDocument').item(0).firstChild.data)
				i = i+1
		return (importDate, idReq, idDocument)


	def gestionEventoCrl(self):
		""" Respuesta a EventoCrl: Genera la página html crl.html 
		conteniendo entre otros una tabla con información y enlaces sobre los 
		certificados revocados por la CA, la crl en formato texto y un enlace 
		de descarga para la crl que activará su mecanismo de actualización.
		"""

		# Necesito conocer el idCA, viene en la URL que es del tipo 
		# "/web/CAs/" + idCA + "/crl.html"
		idCA = self.buscaIdCAenURL()
		
		dirAct = os.getcwd()
		rutaRevocadosXML = dirAct + "/web/CAs/" + idCA + "/revocados.xml"
		xmldoc = None
		if os.path.exists (rutaRevocadosXML):
			xmldoc = minidom.parse(rutaRevocadosXML)
		tuplaListas = self.parseoRevocadosXML(xmldoc)
		self.generaCrlHtml(idCA, tuplaListas)


	def gestionEventoIndex(self):
		""" Respuesta a EventoIndex: Genera la página index.html conteniendo una 
		tabla con información y enlaces a todas las CAs creadas con miARC.
		"""

		# Para ello se analiza del archivo CAs.xml en busca de la información de 
		# los autoridades de certificación generadas con miARC.
		# El nº de CAs habitual es reducido por tanto no supone un retardo a considerar. 
		dirAct = os.getcwd()
		rutaCAsXML = dirAct + "/web/CAs/CAs.xml"
		xmldoc = None
		if os.path.exists (rutaCAsXML):
			xmldoc = minidom.parse(rutaCAsXML)
			# Control de caducacidad de alguna CA: en cada acceso a index.html 
			# se va a comprobar si ha caducado alguna CA y se actúa en consecuencia.
			controlCadCAs(xmldoc)
		tuplaListas = self.parseoCAsXML(xmldoc)
		self.generaIndexHtml(tuplaListas)


	def gestionEventoGestCerts(self):
		""" Respuesta a EventoGestCerts: Genera la página html gestCerts.html 
		conteniendo entre otros una tabla con información y enlaces del último 
		certificado emitido por la CA.
		"""

		# Necesito conocer el idCA, viene en la URL que es del tipo 
		# "/web/CAs/" + idCA + "/gestCerts.html"
		idCA = self.buscaIdCAenURL()
		dirAct = os.getcwd()
		ruta = 	dirAct + "/web/CAs/" + idCA + "/"
		rutaCertsXML = ruta + 'certs.xml'
		xmldoc = None
		if os.path.exists(rutaCertsXML):
			xmldoc = minidom.parse(rutaCertsXML)
			# Control de caducacidad de alguna CA: en cada acceso a index.html 
			# se va a comprobar si ha caducado alguna CA y se actúa en consecuencia.
			controlCadCerts (xmldoc, idCA)
		# Parseo del archivo certs.xml en busca de la información del 
		# último certificado emitidos por la CA.
		tuplaListas = self.parseoCertsXML(xmldoc)
		self.generaGestCertsHtml(idCA, tuplaListas, ruta)


	def gestionEventoBusqReq(self):
		""" Respuesta a EventoBusqReq: Realiza una consulta AJAX sobre el archivo 
		requests.xml en busca de la petición con el número 
		de serie insertado y muestra una tabla con información y enlaces 
		para su gestión.
		"""

		# Aqui tb necesitamos conocer el idCA, como otra opción lo 
		# he pasado a la url mediante GET escondiendo el valor en un 
		# input tipo "hidden" en el html y tratando la URL generada.
		tupla = urllib.splitquery(self.path)
		g = tupla[1]
		indIDReq = g.rindex('=')
		idReq = g[indIDReq+1:]
		dirAct = os.getcwd()
		ruta = 	dirAct + "/requests/"
		self.envia_busqueda_req(ruta, idReq)



	def gestionEventoBusq(self):
		""" Respuesta a EventoBusq: Realiza una consulta AJAX sobre el archivo 
		certs.xml de la CA en cuestión en busca del certificado con el número 
		de serie insertado y muestra una tabla con información y enlaces 
		para su gestión.
		"""

		# Aqui tb necesitamos conocer el idCA, como otra opción lo 
		# he pasado a la url mediante GET escondiendo el valor en un 
		# input tipo "hidden" en el html y tratando la URL generada.
		tupla = urllib.splitquery(self.path)
		g = tupla[1]
		g = g.replace('&', '\n')
		gList = g.splitlines()
		indCA = gList[0].rindex('=')
		idCA = gList[0][indCA+1:]
		indSer = gList[1].rindex('=')
		nSer = gList[1][indSer+1:]

		dirAct = os.getcwd()
		ruta = 	dirAct + "/web/CAs/" + idCA + "/"
		self.envia_busqueda(ruta, nSer)


	def generaIOReqHtml(self, lista):
		""" El parámetro "lista" contiene una lista con datos sobre la última petición importada en el sistema.
		"""
		# Creación del código html
		contenidoHtml = unicode ("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Sistema de Creación y Gestión de Autoridades de Certificación</title>
	<link rel="stylesheet" type="text/css" href="estiloInd.css" media="all">
	<script>
		function pulsar(e) {
		  tecla = (document.all) ? e.keyCode :e.which;
		  return (tecla!=13);
		}
	</script>
	<script type="text/javascript" src="view.js"></script>
	<script languaje="javascript">
	function confirmarBorrado(form)
	{
		borrar = window.confirm('Se borrarán todos los datos del formulario.');
		(borrar)?form.reset():'return false';
	}
		function validar(form)
	{
		mensError = ''
		formCorrecto = true
		// Comprobamos si se ha dejado en blanco el campo
		if(form.pathXML.value == ''){
			mensError += "ERROR: debe indicar el path del archivo XML.\\n"
			formCorrecto = false
		}
		else if(form.pathXML.value != 'requests.xml'){
		// Comprobamos que no se trata de otro que del archivo "requests.xml"
			mensError += "ERROR: el archivo debe ser el 'requests.xml' de la RA.\\n"
			formCorrecto = false
		}
		if (!formCorrecto)
			alert(mensError)
		return formCorrecto
	}
	</script>
</head>
<body id="main_body" >
	<img id="top" src="./images/top.png" alt="">
	<img src="./images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="./index.html" /></map>
	<div id="contenedor">
		<br>
		<form id="form_38911" class="appnitro" method="post" enctype="multipart/form-data" action="http://localhost:8000/cgi-bin/importarReq.py" onSubmit = "return validar(this)">
			<div class="form_description">
				<h2>Importar archivo XML de Peticiones.</h2>
				<p>Para importar un nuevo XML conteniendo peticiones registradas en el servidor rellene el campo con el path donde se encuentre y pinche el botón 'Importar'.</p>
			
				<li id="li_1" >
					<label class="description" for="pathXML">*Archivo XML: </label>
					<div>
						<input id="pathXML" name="pathXML" class="element file" type="file"/> 
					</div><p class="guidelines" id="guide_1"><small>Seleccione el archivo con extensión '.xml' que contiene las peticiones.</small></p> 
					<div>
						<input type="hidden" name="form_id" value="38911" />
						<input id="saveForm" class="button_text" type="submit" name="submit" value="Importar"/>
						<input type="button" value="Borrar" onClick="confirmarBorrado(this.form)"/>			
					</div>
				</li>
		<div class="section_break"></div>
		</form>""", 'utf-8')


		if len(lista) > 0:				# Si se ha importado alguna petición
			contenidoHtml += unicode("""\n\t\t			
				<h2>Gestión de Peticiones Importadas.</h2>
				<p>Puede buscar cualquier petición importada introduciendo su identificador en el siquiente campo, por defecto se muestra el último emitido.</p>
				<p>Recuerde que el número identificador de la petición está formado por los dígitos del código de seguridad previos al símbolo de subrayado.</p>
				<form id="form_petImp" name="form_petImp" class="appnitro" method="post" onSubmit="return validarIdPet(this)">
				<li id="li_2">
				<div>
					Número Identificador:
					<input id="numIdPet" name="numIdPet" class="element text small" type="text" maxlength="255" onkeypress="return pulsar(event)"/> 					<input class="button_text" type="button" name="button" value="Buscar" onclick="javascript: hazPeticion('ioReq.html', this.parentNode);" />
				</div>
				</li>
				<div id="contenedor2">
					<div id="datos">
						<table id="tablaPets" width="100%" border="0" align="center" cellpadding="1" cellspacing="1">
							<tr id="cabecera" bgcolor="#CCCCCC">
								<td><div align="center">Número Identificador</div></td>
								<td><div align="center">Identificación del Propietario</div></td>
								<td><div align="center">Estado</div></td>
								<td><div align="center">Detalles</div></td>
							</tr>
							<tr id="cert_1">
								<td><div id="idPet_1" align="center">""" + str(lista[0].encode('utf-8')) + """</div></td>
								<td><div id="datos_1" align="center">NIF/CIF: """ + str(lista[1].encode('utf-8')) + """<br />Código: """ + str(lista[2].encode('utf-8')) + """</div></td>""", 'utf-8')

			if lista[3] == "espera":
				contenidoHtml += unicode("""\n\t\t\t\t\t\t\t\t<td><div id="estado_1" align="center"><img src="../web/images/icons/hourglass.png" title="Petición esperando ser tratada." width="16" height="16" border="0" />"</div></td>""", 'utf-8')
			elif lista[3] == "aceptada":
				contenidoHtml += unicode("""\n\t\t\t\t\t\t\t\t<td><div id="estado_1" align="center"><img src="../web/images/icons/thumb_up.png" title="Petición aceptada." width="16" height="16" border="0" /></div></td>""", 'utf-8')
			elif lista[3] == "rechazada":
				contenidoHtml += unicode("""\n\t\t\t\t\t\t\t\t<td><div id="estado_1" align="center"><img src="../web/images/icons/thumb_down.png" title="Petición rechazada." width="16" height="16" border="0" /></div></td>""", 'utf-8')

			contenidoHtml += unicode("""\n\t\t\t\t\t\t\t\t<td><div id="observar_1" align="center"><a href="./requests/id_""" + str(lista[0].encode('utf-8')) + """_req.html"><img src="../web/images/icons/magnifier.png" title="Ver configuración de la petición." width="16" height="16" border="0" /></a></div></td>
							</tr>
						</table>
					</div>
				</div>
				<br/>
				<p>Si no dispone del número identificador de la petición haga uso de la <a href="./busqAvanz.html"><img src="../web/images/icons/find.png" alt="Búsqueda Avanzada" width="16" height="16" />Búsqueda Avanzada</a>.</p>
			</div>""", 'utf-8')

		contenidoHtml += unicode("""\n\t<div id="footer">
		<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
	</div>
	</form>
	</div>
	<img id="bottom" src="./images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
		dirAct = os.getcwd()
		f = open (dirAct + '/web/ioReq.html', 'w')
		f.write(contenidoHtml.encode('utf-8'))
		f.close()



	def generaCrlHtml (self, idCA, tuplaListas):
		"""Creación del archivo /web/CAs/idCA/crl.html
		"""
		# directorio donde guardaremos crl.html
		dirAct = os.getcwd()
		pathDir = dirAct + '/web/CAs/' + idCA + '/'
		if not os.path.exists (pathDir):
			os.mkdir(pathDir)

		pathCRL = dirAct + '/CAs/' + idCA + '/' + idCA + 'PEM.crl'
		try:
			# dando formato texto a la CRL
			crl = X509.load_crl(pathCRL)
			crlText = crl.as_text()
		except IOError:		# no existe el archivo .crl o no es válido
			crlText = "No existe lista de revocación, puede crear una en la subsección: 'Descargar CRL'."


		# registro de certificados revocados
		l = len(tuplaListas[0])
		if l == 0:		# es decir, no existe ningún certificado revocado
			registroRev = "</div><pre>El registro se encuentra actualmente vacío, aún no se ha revocado ningún certificado.</pre>"
		else:
			inicioTabla = """<h3><u>Registro de Certificados Revocados.</u></h3>
				<div><p>Listado con aquellos certificados emitidos y revocados por la autoridad: <B>""" + idCA + """</B>, sus fechas de revocación y un enlace a sus páginas de configuración.</p></div>
			</div><br/>
				<table width="80%" border="0" align="center" cellpadding="3" cellspacing="0">
				<tbody>
					<tr bgcolor="#000000">
						<td width="27%"><div align="center"><font color="#ffffff">Número de Serie.</font></div></td>
						<td width="61%"><div align="center"><font color="#ffffff">Fecha de Revocación.</font></div></td>
						<td width="12&"><div align="center"><font color="#ffffff">Ver.</font></div></td>
					</tr>"""
			contenido = ""
			i = 0
			while i < l:
				# dando color al fondo de las filas de la tabla
				if i%2 != 0:
					colorFila = "#fff7c0"
				else:
					colorFila = "#ffffff"

				contenido = contenido + """\n\t\t\t\t\t<tr bgcolor='""" + colorFila + """'>
						<td><div align="center">""" + str(tuplaListas[0][i]) + """</div></td>
						<td><div align="center">""" + str(tuplaListas[1][i]) + """</div></td>"""
				# controlamos si es el certificado raíz de la CA para modificar 
				# el destino del enlace "Ver"
				if str(tuplaListas[0][i]) == '0':
					contenido += """<td><div align="center"><a href='./""" + idCA + """.html'><img src="../../images/icons/zoom.png" title='Ver configuración del certificado.' width="16" height="16" /></a></div></td>"""
				else:
					contenido += """<td><div align="center"><a href='./certs/""" + str(tuplaListas[0][i]) + """.html'><img src="../../images/icons/zoom.png" title='Ver configuración del certificado.' width="16" height="16" /></a></div></td>"""

				contenido +="""
					</tr>"""
				i = i + 1
			finTabla = """\n\t\t\t\t</tbody>
			</table>
			<br/>"""
			registroRev = inicioTabla + contenido + finTabla

		contenido1 = unicode ("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Lista de Revocación de Certificados de la Autoridad de Certificación """ + idCA + """.</title>
	<link rel="stylesheet" type="text/css" href="../../estiloInd.css" media="all">
	<script type="text/javascript" src="../../view.js"></script>
	<script type="text/javascript" src="../../calendar.js"></script>
	<script languaje="javascript">
	function validar(form)
	{
		mensError = ''
		formCorrecto = true

		// Comprobamos que no se ha rellenado al menos un campo de la fecha de 
		// próxima actualización y hay alguno vacío (dia/mes/año)
		if ((form.fechaProxAct_1.value == '' && (form.fechaProxAct_2.value != '' || form.fechaProxAct_3.value != '')) || (form.fechaProxAct_2.value == '' && (form.fechaProxAct_1.value != '' || form.fechaProxAct_3.value != ''))	|| (form.fechaProxAct_3.value == '' && (form.fechaProxAct_1.value != '' || form.fechaProxAct_2.value != ''))){
			mensError += "ERROR: Ha rellenado alguno de los campos de de la fecha de próxima actualización pero no la ha completado.\\n"
			formCorrecto = false
		}

		// Comprobamos que la fecha introducida es posterior a la actual
		if (form.fechaProxAct_1.value != '' && form.fechaProxAct_2.value != '' && form.fechaProxAct_3.value != ''){
			fechaActual = new Date()
			cadFechaIntro = form.fechaProxAct_2.value + '/' + form.fechaProxAct_1.value + '/' + form.fechaProxAct_3.value
			fechaInt = new Date(cadFechaIntro)
			if (fechaInt < fechaActual){
				mensError += "ERROR: la fecha de próxima actualización de la CRL debe ser posterior a la actual.\\n"
				formCorrecto = false
			}
		}

		if (!formCorrecto)
			alert(mensError)
		return formCorrecto
	}
	</script>
	<style type="text/css">
		lis {clear:both; display:table;}
		span {float:left; padding: 0 20px 0 20px;}
	</style>
	<script type="text/javascript">
	function seleccion(opc)
	{
		//escondemos todos los contenidos
		document.getElementById("op1").style.display="none";
		document.getElementById("op2").style.display="none";
		document.getElementById("op3").style.display="none";
		document.getElementById("op4").style.display="none";
		switch(opc)
		{
			case 1:
				//mostramos el contenido de la primera opción
				document.getElementById("op1").style.display="block";
				break;
			case 2:
				//mostramos el contenido de la segunda opción
				document.getElementById("op2").style.display="block";
				break;
			case 3:
				//mostramos el contenido de la tercera opción
				document.getElementById("op3").style.display="block";
				break;
			case 4:
				//mostramos el contenido de la cuarta opción
				document.getElementById("op4").style.display="block";
				break;
		}
	}
	</script>
	<script type="text/javascript">
	function confirmarRevocacion(idCA)
	{
		revocar = window.confirm('¿Está seguro de que desea revocar la autoridad de certificación: ' + idCA + '?');
		if (!revocar)
			return false;
	}
	</script>
</head>
<body id="main_body" >
	<img id="top" src="../../images/top.png" alt="">
	<img src="../../images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../../index.html" /></map>
	<div id="contenedor">
		<br>
		<form id="form_39443" class="appnitro">
		<div class="form_description">
			<h2>Lista de revocación de certificados de la CA: """ + idCA + """.</h2>
			<p>Esta página le permite observar el registro de certificados revocados y descargar la lista de revocación de la autoridad de certificación <B>""" + idCA + """</B>.</p>
		</div>
		<ul>
		<li>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
			<tbody>
			<tr>
				<td width="12%" class="imagen">
					<img src="../../CAs/""" + idCA + """/candado.png" alt="" title="" border="0" height="60" width="60">
				</td>
				<td width="40%" class="preview">
					<p><strong>idCA: </strong>""" + idCA + """<br/><strong>Fecha de Revocación: </strong>""" + """</p>
				</td>
				<td width="48%" class="enlace">
					<a href="../../../web/CAs/""" + idCA + """/""" + idCA + """.html" class=""><img src="../../images/icons/building.png" width="16" height="16" />  Información General</a><br/>
					<a href="./gestCerts.html" class=""><img src="../../images/icons/script.png" width="16" height="16" /> Gestionar Certificados</a><br/>
				</td>
			</tr>
			</tbody>
			</table>
		</li>
		<div class="section_break"></div>
		<br/>
		</form>
		<lis>
			<span style="border-right:1px solid;"><a href='javascript:seleccion(1);'><img src="../../images/icons/magnifier_zoom_in.png" width="16" height="16" /> Registro de Revocaciones</a></span>
			<span style="border-right:1px solid;"><a href='javascript:seleccion(2);'><img src="../../images/icons/script.png" width="16" height="16" /> Ver CRL</a></span>
			<span style="border-right:1px solid;"><a href='javascript:seleccion(3);'><img src="../../images/icons/script.png" width="16" height="16" /> Descargar CRL</a></span>
			<span style="border-right:0px solid;"><a href='javascript:seleccion(4);'><img src="../../images/icons/script.png" width="16" height="16" /> Revocar CA</a></span>
		</lis>
		<lis id="op1" style="display:block;width:99%;height:100%;"><br/><br/>
			<div class="section_break">
				""" + registroRev + """
			<div class="section_break"></div>
		</lis>
		<lis id="op2" style="display:none;width:99%;height:100%;"><br/><br/>
			<div class="section_break"></div>
			<pre>""" + crlText + """</pre>
			<div class="section_break"></div>
		</lis>
		<lis id="op3" style="display:none;width:99%;height:100%;"><br/><br/>
		<div class="section_break"></div>
			<form id="form" class="appnitro" method="post" action="http://localhost:8000/cgi-bin/descCRL.py" onSubmit="return validar(this)">
				<div class="form_description">
					<h2>Descarga de la Lista de Revocación de Certificados.</h2>
					<p>La descarga de la CRL requiere de un proceso previo, seleccione las opciones deseadas y pulse el botón "Descargar Lista de Revocación de Certificados".</p>
					<ul>
					<li id="li_1">
						<label class="description" for="algFirma">Algoritmo de Firma: </label>					
						<select class="element select small" id="firma" name="firma"> 
							<option value="md5" >MD5</option>
							<option value="sha1" selected="selected">SHA1 (DSS1)</option>
							<option value="sha224" >SHA224</option>
							<option value="sha256" >SHA256</option>
							<option value="ripemd160" >RIPEMD-160</option>
						</select>
						<p class="guidelines" id="guide_17"><small>Seleccione el algoritmo con el que desea que sea firmada la CRL.</small></p>
					</li>
					<li id="li_2">
						<label class="description" for="fechaProxAct">Fecha de la próxima actualización: </label>
						<span>
							<input id="fechaProxAct_1" name="fechaProxAct_1" class="element text" size="2" maxlength="2" value="" type="text"> /
							<label for="fechaProxAct_1">DD</label>
						</span>
						<span>
							<input id="fechaProxAct_2" name="fechaProxAct_2" class="element text" size="2" maxlength="2" value="" type="text"> /
							<label for="fechaProxAct_2">MM</label>
						</span>
						<span>
					 		<input id="fechaProxAct_3" name="fechaProxAct_3" class="element text" size="4" maxlength="4" value="" type="text">
							<label for="fechaProxAct_3">AAAA</label>
						</span>
						<span id="calendar_2">
							<img id="cal_img_2" class="datepicker" src="../../images/calendar.gif" alt="Seleccione una fecha.">	
						</span>
						<script type="text/javascript">
							Calendar.setup({
								inputField	 : "fechaProxAct_3",
								baseField    : "fechaProxAct",
								displayArea  : "calendar_2",
								button		 : "cal_img_2",
								ifFormat	 : "%B %e, %Y",
								onSelect	 : selectEuropeDate
							});
						</script>
						<p class="guidelines" id="guide_2"><small>OPCIONAL: Puede informar a los usuarios de la fecha en tendrá lugar la siguiente actualización de la lista de revocación de esta autoridad.</small></p>
					</li>
					</ul>
					<br/>
					<div align = "center">
						<input id="idCA" name="idCA" class="element text medium" type="hidden" maxlength="255" value='""" + idCA + """'/>
						<input id="saveForm" class="button_text" type="submit" name="submit" value="Descargar Lista de Revocación de Certificados"/>
					</div>
					<br/>
				</div>
			</form>
		</lis>
		<lis id="op4" style="display:none;width:99%;height:100%;"><br/><br/>
			<div class="section_break">""", 'utf-8')

		revCAContenido1 = unicode("""<h3><u><b>Aviso Importante.</b></u></h3>
				<div><p>La revocación de una autoridad de certificación supone la revocación de su certificado raíz, inhabilitando todos los certificados emitidos con la misma.</p></div>
				<div><p>Una vez la autoridad de certificación esté revocada no podrá emitir certificados ni listas de revocación con ella y se recomienda que publique la CRL generada tras la revocación urgentemente para notificar de la invalidez de la misma y de sus certificados a los clientes lo  más rápidamente posible.</p></div>
				<div><p>El proceso de revocación de una autoridad de certificación solo debe llevarse a cabo cuando haya sido comprometida la seguridad de su clave privada y a pesar de la publicación de la CRL generada en el proceso de revocación, este hecho puede desembocar en graves problemas de seguridad para los clientes de la misma.</p></div>
			</div>
			<form id="form_revCA" name="form_revCA" class="appnitro"  method="post" action="http://localhost:8000/cgi-bin/revocarCA.py" onSubmit = "return confirmarRevocacion('""" + idCA + """')">
				<input type=hidden id="idCA" name="idCA" class="element text medium" type="text" maxlength="255" value='""" + idCA + """'/>
				<br/>
				<div align="center"><input id="saveForm" class="button_text" type="submit" name="submit" value="Revocar Autoridad de Certificación:  """ + idCA + """"./></div>
			</form>""", 'utf-8')

		revCAContenido2 = unicode("""\n\t\t<h3><u>La autoridad de certificación no puede ser revocada.</u></h3>
				<div><p>La autoridad de certificación <b>""" + idCA + """</b> ya ha caducado o ha sido revocada, puede comprobarlo observando el color del logotipo con el símbolo del candado en la zona superior junto al identificador de la autoridad, si su color es negro significa que la autoridad está revocada y si es rojo que está caducada.<p></div>
				<div><p>El estado de caducado o revocado de un certificado es irreversible, es decir, ha perdido su validez y no puede volver a ella, esto afecta de igual manera al certificado raíz de una autoridad de certificación, es decir, esta autoridad no puede volver a emitir nuevos certificados o nuevas listas de revocación de certificados.<p></div><br/>
			""", 'utf-8')

		contenido2 = unicode("""\n\t\t<div class="section_break"></div>
		</lis>
		</ul>
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../../images/bottom.png" alt="">
</body>
</html>""", 'utf-8')

		# dependiendo si la CA está el código cambia
		if not estaCadORev (idCA):
			contenido = contenido1 + revCAContenido1 + contenido2
		else:
			contenido = contenido1 + revCAContenido2 + contenido2

		f = open(pathDir + 'crl.html', 'w') 		# creamos el archivo
		f.write(contenido.encode("utf-8"))
		f.close()



	def parseoRevocadosXML (self, xmldoc=None):
		""" Realiza un análisis del documento revocados.xml situado en 
		/web/CAs/idCA para obtener los valores de las etiquetas '<numSerie>' y 
		'<fechaRev>' de todos los certificados revocados por esa CA.

		Devuelve una tupla de listas.
		"""

		# Obteniendo los valores de '/web/CAs/idCA/revocados.xml'
		numSerie = []
		fechaRev = []
		if xmldoc != None:
			certsLista = xmldoc.getElementsByTagName('certificado')
			l = len(certsLista)
			i = 0
			while i < l:
				numSerie.append (certsLista[i].getElementsByTagName('numSerie').item(0).firstChild.data)
				fechaRev.append (certsLista[i].getElementsByTagName('fechaRev').item(0).firstChild.data)
				i = i+1
		return (numSerie, fechaRev)


	def parseoCAsXML (self, xmldoc = None):
		""" Realiza un análisis del documento CAs.xml situado en /web/CAs/ 
		para obtener los valores de las etiquetas 'id', 'cn', 'o', 'fechaRev' y 
		'estado' de todas las CAs creadas con miARC.

		Devuelve una tupla de listas.
		"""

		# Obteniendo los valores de '/web/CAs/CAs.xml'
		idCA = []		# se refiere a la etiqueta <id>, pero id es palabra reservada de Python
		cn = []
		o = []
		fechaRev = []
		estado = []
		if xmldoc != None:
			caLista = xmldoc.getElementsByTagName('ca')
			l = len(caLista)
			i = 0
			while i < l:
				idCA.append (caLista[i].attributes["id"].value)
				cn.append (caLista[i].getElementsByTagName('cn').item(0).firstChild.data)
				o.append (caLista[i].getElementsByTagName('o').item(0).firstChild.data)
				fechaRev.append (caLista[i].getElementsByTagName('fechaRev').item(0).firstChild.data)
				estado.append (caLista[i].getElementsByTagName('estado').item(0).firstChild.data)
				i = i+1
		return (idCA, cn, o, fechaRev, estado)


	def generaIndexHtml(self, tuplaListas):
		""" A partir del parseo y la obtención de la información de las CAs 
		crea el código html de la página principal. 
		"""

		dirAct = os.getcwd()
		# Creación del código html
		# La primera parte siempre se mostrará, incluso cuando no haya ninguna CA.
		contenidoHtml = unicode ("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="express" content="-1">
	<meta http-equiv="Expires: Wed, 05 Nov 2003 16:46:04 GMT">
	<meta http-equiv="Last-Modified:Tue, 12 May 1998 22:18:49 GMT">
	<meta http-equiv="Cache-Control" content="no-cache, mustrevalidate">
	<meta http-equiv="Pragma" content="no-cache">
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Sistema de Creación y Gestión de Autoridades de Certificación</title>
	<link rel="stylesheet" type="text/css" href="estiloInd.css" media="all">
	<link rel="shortcut icon" href="./favicon.ico">
	<script type="text/javascript" src="view.js"></script>
</head>
<body id="main_body">
	<img id="top" src="images/top.png" alt="">	
	<img src="./images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="index.html" /></map>
	<div id="contenedor">
		<br />
		<form id="form_39443" class="appnitro">""", 'utf-8')

		# Comprueba si el parseo del documento CAs.xml ha encontrado alguna CA 
		# y si es el caso muestra los enlaces para gestionar peticiones.
		num = len(tuplaListas[0])
		if num > 0:
			contenidoHtml = contenidoHtml + unicode("""\n\t\t<div class="form_description">
			<h2>Gestión de Peticiones.</h2>
			<p>Mediante los siguientes enlaces puede importar el archivo XML conteniendo las peticiones de certificados registradas en la Autoridad de Registro o tratar las que ya haya importado.</p>
			<table width="100%" height="35px" border="0">
				<tr>
					<td>
						<div align="center"><a href="./ioReq.html"><img src="images/icons/database_refresh.png" width="16" height="16" /> Gestión de la Entrada/Salida de datos.</a></div>
					</td>""", 'utf-8')
		if os.path.exists(dirAct + '/requests/requests.xml'):
			contenidoHtml += unicode("""\n\t\t\t\t\t<td>
						<div align="center"><a href="./tratReq.html"><img src="images/icons/table_edit.png" width="16" height="16" /> Tratamiento de peticiones ya importadas.</a></div>
					</td>""", 'utf-8')
		contenidoHtml += unicode("""\n\t\t\t\t</tr>
			</table>
		</div>""", 'utf-8')


		# Cabecera de las tablas conteniendo la info y enlaces de las CAs siempre aparece.
		contenidoHtml = contenidoHtml + unicode ("""\n\t\t<ul>
		<div class="form_description">
			<h2>Gestión de Autoridades de Certificación.</h2>
			<p>Los siguientes enlaces presentan las opciones de creación de nuevas Autoridades de Certificación, a continuación se encuentran todas las ya creadas con enlaces para su gestión.</p>
			<table width="100%" height="35px" border="0">
				<tr>
					<td>
						<div align="center"><a href="forms/formNCA.html"><img src="images/icons/building_add.png" width="16" height="16" /> Crear nueva CA desde cero.</a></div>
					</td>
					<td>
						<div align="center"><a href="forms/formNCAIC.html"><img src="images/icons/building_link.png" width="16" height="16" /> Crear nueva CA importando certificado raíz y claves RSA.</a></div></td>
					</td>
				</tr>
			</table>
		</div>""", 'utf-8')


		# Comprueba si el parseo del documento CAs.xml ha encontrado alguna CA 
		# y crea una tabla con las CAs existentes.
		if num > 0:
			# Creación de las tablas conteniendo la info y enlaces de las CAs.
			while num > 0:

# XXX XXX ACTUALIZACION 14 AGOSTO XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX 
#				# Comprobando si la CA tiene Lista de Revocación de Certificados (CRL)
#				if not os.path.exists (dirAct + '/CAs/' + str(tuplaListas[0][num-1]) + '/' + str(tuplaListas[0][num-1]) + '.crl'):
#					# En caso negativo, el enlace muestra una alerta.
#					enlaceCRL = """<a href="javascript:alert('Aviso: No existe actualmente ningún certificado revocado para esta CA.')"><img src="../web/iconos/report.png" width="16" height="16" /> Lista de Revocación de Certificados</a>"""
#				else:
#					# En caso positivo se genera el enlace a la página de info de la CRL.
#					enlaceCRL = """<a href="../CAs/""" + str(tuplaListas[0][num-1]) + """/""" + str(tuplaListas[0][num-1]) + """PEM.crl"><img src="../web/iconos/report.png" width="16" height="16" /> Lista de Revocación de Certificados</a>"""
# XXX XXX /ACTUALIZACION 14 AGOSTO XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX XXX 


				# Comprobando el estado de cada CA para poner el icono del candado 
				# del color y el campo 'title' que le corresponde.
				title = "CA en activo, puede emitir certificados y listas de revocación con normalidad." 
				if str(tuplaListas[4][num-1]) == 'caducado':
					copiarArchivo(dirAct + '/web/images/icons/candadoCad.png', dirAct + '/web/CAs/' + str(tuplaListas[0][num-1]) + '/candado.png')
					title = "CA caducada, el certificado raíz ha alcanzado su fecha de caducidad y la CA deja de ser funcional."
				elif str(tuplaListas[4][num-1]) == 'revocado':
					title = "CA revocada, un operador ha revocado esta CA y por tanto deja de ser funcional."

				# Estructura html de cada tabla correspondiente a cada CA existente.
				tablaHtml = unicode ("""\n\t\t\t<li>
			<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
				<tbody>
					<tr>
						<td width="12%" class="imagen"><a href='./CAs/""" + str(tuplaListas[0][num-1].encode('utf-8')) + """/""" + str(tuplaListas[0][num-1].encode('utf-8')) + """.html'><img src="../web/CAs/""" + str(tuplaListas[0][num-1].encode('utf-8')) + """/candado.png" alt="" title='""" + title + """' border="0" height="60" width="60"></a>
						</td>
						<td width="40%" class="preview"><p><strong>idCA: </strong>""" + str(tuplaListas[0][num-1].encode('utf-8')) + """<br />
						  <strong>Nombre: </strong>""" + str(tuplaListas[1][num-1].encode('utf-8')) + """<br />
						  <strong>Organización: </strong>""" + str(tuplaListas[2][num-1].encode('utf-8')) + """<br />
						  <strong>Fecha de Caducidad: </strong>""" + str(tuplaListas[3][num-1].encode('utf-8')) + """</p>
						</td>
						<td width="48%" class="enlace">
							<a href='./CAs/""" + str(tuplaListas[0][num-1].encode('utf-8')) + """/""" + str(tuplaListas[0][num-1].encode('utf-8')) + """.html'><img src="../web/images/icons/building.png" width="16" height="16" /> Información General</a><br/>
							<a href="./CAs/""" + str(tuplaListas[0][num-1].encode('utf-8')) + """/gestCerts.html"><img src="../web/images/icons/script.png" width="16" height="16" /> Gestión de Certificados</a><br/>
							<a href="./CAs/""" + str(tuplaListas[0][num-1].encode('utf-8')) + """/crl.html"><img src="../web/images/icons/report.png" width="16" height="16" /> Lista de Revocación de Certificados</a>
						</td>
					</tr>
				</tbody>
			</table>
			</li>
			<div class="section_break"></div>""", 'utf-8')
				contenidoHtml += tablaHtml
				num = num-1

		# Pie de página, siempre se mostrará incluso si no hay CAs.
		contenidoHtml = contenidoHtml + unicode ("""\n\t\t\t</ul>
		</form>
	<div id="footer">
		<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
	</div>
	</div>
	<img id="bottom" src="images/bottom.png" alt="">
</body>
</html>""", 'utf-8')

		f = open (dirAct + '/web/index.html', 'w')
		f.write(contenidoHtml.encode('utf-8'))
		f.close()

	def buscaIdCAenURL (self):
		""" Devuelve el identificador de la CA contenido en la URL a la que se
		ha accedido. 
		"""
		urlModif = self.path.replace('/', '\n')
		urlList = urlModif.splitlines()
		idCA = urlList[len(urlList)-2]
		return idCA

	def parseoCertsXML(self, xmldoc):
		""" Realiza un parseo del documento certs.xml situado en el path 'ruta' 
		pasado como argumento para obtener los atributos ns, cn, sn, o y ou del 
		último certificados emitidos por la CA.
		Devuelve una tupla. """
		# Generamos toda la página incluyendo el acceso al XML
		# Obteniendo los valores de certs.xml
		# Las etiquetas de los campos que queremos del XML para cada certificado: 'ns', 'cn', 'sn', 'o', 'ou' y 'est'
		ns = None
		cn = None
		sn = None
		o = None
		ou = None
		est = None
		certLista = xmldoc.getElementsByTagName('cert')
		l = len(certLista)
		if l > 0:
			ns = certLista[l-1].attributes["numSer"].value
			cn = certLista[l-1].getElementsByTagName('cn').item(0).firstChild.data
			sn = certLista[l-1].getElementsByTagName('sn').item(0).firstChild.data
			o = certLista[l-1].getElementsByTagName('o').item(0).firstChild.data
			ou = certLista[l-1].getElementsByTagName('ou').item(0).firstChild.data
			est = certLista[l-1].getElementsByTagName('estado').item(0).firstChild.data
		return (ns, cn, sn, o, ou, est)


	def generaGestCertsHtml(self, idCA, tupla, ruta):

		# comprobamos el estado de cada certificado para en el caso en que 
		# esté revocado o caducado sustituir la checkbox por un gif representativo
		if str(tupla[5]) == 'revocado':
			codigoRev = """<a href="#" onClick="alert('El certificado emitido por la CA: """ + idCA + """ y con número de serie: """ + str(tupla[0]) + """ ya se encuentra revocado.');return false;"/><img src="../../images/icons/cancel.png" title="Este certificado se encuentra revocado." width="16" height="16" border="0" />"""

		elif str(tupla[5]) == 'caducado':
			codigoRev = """<a href="#" onClick="alert('El certificado emitido por la CA: """ + idCA + """ y con número de serie: """ + str(tupla[0]) + """ ya ha caducado.');return false;"/><img src="../../images/icons/time_delete.png" title="Este certificado se encuentra caducado." width="16" height="16" border="0" />"""

		elif str(tupla[5]) == 'valido':
			codigoRev = """<input type="checkbox" name="revocado1CHB" />"""

		else:
			codigoRev = """"""

		htmlIni = unicode ("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>miARC - Sistema de Creación y Gestión de Autoridades de Certificación</title>
	<link rel="stylesheet" type="text/css" href="../../estiloInd.css" media="all">
	<script>
		function pulsar(e) {
		  tecla = (document.all) ? e.keyCode :e.which;
		  return (tecla!=13);
		}
	</script>
	<script type="text/javascript" src="../../view.js"></script>
	<script languaje="javascript">
	function validar(form)
	{
		mensError = ''
		formCorrecto = true
		// Comprobamos si existe el checkbox
		obj = form['revocado1CHB'];
  		if(obj != undefined){
			// Comprobamos si se ha marcado la casilla revocar.
			if (!form.revocado1CHB.checked) {
				mensError += "ERROR: no ha seleccionado la casilla 'Revocar' del certificado mostrado.\\n"
				formCorrecto = false
        	}
		}
		else{ 				// si no existe
			mensError += "ERROR: el certificado mostrado ya se encuentra revocado o caducado.\\n"
			formCorrecto = false

		}
		if (!formCorrecto)
			alert(mensError)
		return formCorrecto
	}
	function deshabilitar()
	// deshabilita el checkbox en el caso que estuviera habilitado
	{
		if (document.form_rev.revocado1CHB.checked) {
			document.form_rev.revocado1CHB.checked = !document.forms[1].revocado1CHB.checked
		}
	}
	</script>
</head>
<body id="main_body" onload="deshabilitar()">
	<img id="top" src="../../images/top.png" alt="">	
	<img src="../../images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<map name="myARCLogoMap" id="myARCLogoMap"><area shape="rect" coords="21,2,243,59" href="../../index.html" /></map>
	<div id="contenedor">
		<br/>
		<form id="form_rev" class="appnitro">
		<div class="form_description">
			<h2>Zona de Gestión de  Certificados de la CA: """ + idCA + """.</h2>
			<p>Desde esta página parte toda la funcionalidad de la autoridad de certificación, contiene las opciones para generar nuevos certificados y para consultarlos y revocarlos en el caso en que ya los haya emitido.</p>
		</div>
		<li>
		<table width="100%" border="0" align="center" cellpadding="0" cellspacing="0" id="idCA">
			<tbody>
			<tr>
				<td width="12%" class="imagen">
					<img src="../../CAs/""" + idCA + """/candado.png" alt="" title="" border="0" height="60" width="60">
				</td>
				<td width="40%" class="preview">
					<p><strong>idCA: </strong>""" + idCA + """<br/><strong>Fecha de Revocación: </strong></p>
				</td>
				<td width="48%" class="enlace">
					<a href="./""" + idCA + """.html" class=""><img src="../../images/icons/building.png" width="16" height="16" /> Información General</a><br/>
				  	<a href="../../../web/CAs/""" + idCA + """/crl.html" class=""><img src="../../images/icons/report.png" width="16" height="16" /> Lista de Revocación de Certificados</a>
				</td>
			</tr>
			</tbody>
		</table>
		</li>
		<div class="section_break"></div>
		<div class="form_description">""", 'utf-8')

		htmlEmitirNC = unicode("""\n\t\t
        	<h2>Emitir Nuevo Certificado Digital...</h2>
			<table width="93%" align="center">
				<tr>
					<td>
						<a href="./formNC.html"><img src="../../images/icons/script_add.png" alt="Nuevo Certificado desde Cero" width="16" height="16" /> desde cero</a>: Genera un nuevo certificado con nuevo par de claves.<br/>
					</td>
				</tr>
				<tr>
					<td>
						<a href="../../forms/formNCIP.html"><img src="../../images/icons/script_link.png" alt="Nuevo Certificado importando claves RSA" width="16" height="16" /> importando claves</a>: A partir del archivo conteniendo la clave privada RSA.
					</td>
				</tr>
				<tr height="5px"></tr>
			</table>
		""", 'utf-8')

		htmlFin = unicode ("""\n\t\t</form>
		</div>
	<div id="footer">
		<p>Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p></div>
	</div>
	<img id="bottom" src="../../images/bottom.png" alt="">
</body>
</html>""", 'utf-8')

		f = open(ruta + 'gestCerts.html', 'w')
		contenidoHTML = htmlIni

		# si la CA no está revocada o caducada se permite emitir certificados
		if not estaCadORev (idCA):
			contenidoHTML += htmlEmitirNC

		i = tupla[0]
		if i != None:
			htmlGestCert = unicode ("""\n\t\t<div class="section_break"></div>
				<h2>Gestión de Certificados Emitidos.</h2>
				<p>Puede buscar cualquier certificado emitido por esta autoridad introduciendo su número de serie en el siquiente campo, por defecto se muestra el último emitido.</p>
				<li id="li_1">
				<div>
					<input type=hidden id="idCA" name="idCA" class="element text medium" maxlength="255" value='""" + idCA + """'/>
					Número de Serie: 
					<input id="serial" name="serial" class="element text small" type="text" maxlength="255" onkeypress="return pulsar(event)"/> 	<input class="button_text" type="button" name="button" value="Buscar" onclick="javascript: hazPeticion('gestCerts.html', this.parentNode);" />
				</div>
				</li>
			</form>
			<form id="form_rev" name="form_rev" class="appnitro"  method="post" action="http://localhost:8000/cgi-bin/revocar.py" onSubmit = "return validar(this)">
			<input type=hidden id="idCA" name="idCA" class="element text medium" type="text" maxlength="255" value='""" + idCA + """'/>
			<div id="contenedor2">
				<div id="datos">
					<table id="tablaCerts" width="100%" border="0" align="center" cellpadding="1" cellspacing="1">
						<tr  id="cabecera" bgcolor="#CCCCCC">
							<td><div align="center">Número de Serie</div></td>
							<td><div align="center">Información del Propietario</div></td>
							<td><div align="center">Detalles</div></td>
							<td><div align="center">Revocar</div></td>
						</tr>
						<tr id="cert_1">
							<td><div id="serie_1" align="center">""" + str(tupla[0].encode('utf-8')) + """</div></td>
							<td><div id="datos_1" align="center">""" + str(tupla[1].encode('utf-8')) + ' ' + str(tupla[2].encode('utf-8')) + """<br />
							""" + str(tupla[3].encode('utf-8')) + """ (""" + str(tupla[4].encode('utf-8')) + """)</div></td>
							<td><div id="observar_1" align="center"><a href="./certs/""" + str(tupla[0].encode('utf-8')) + """.html"><img src="../../images/icons/magnifier.png" title="Ver configuración del certificado." width="16" height="16" border="0" /></a></div></td>
							<td><div id="revocar_1" align="center">""" + codigoRev + """</div></td>
							<input type=hidden id="revocado1Serial" name="revocado1Serial" class="element text medium" type="text" maxlength="255" value='""" + str(tupla[0].encode('utf-8')) + """'/>
						</tr>
					</table>
				</div>
			</div>
			<br/>
			<div align="center"><input id="saveForm" class="button_text" type="submit" name="submit" value="Revocar el Certificado Seleccionado" /></div>
			<br/>
			<p>Si no dispone del número de serie del certificado haga uso de la <a href="../../busqAvanz.html"><img src="../../images/icons/find.png" alt="Búsqueda Avanzada" width="16" height="16" />Búsqueda Avanzada</a>.</p>
			""", 'utf-8')
			contenidoHTML += htmlGestCert
		contenidoHTML += htmlFin
		f.write(contenidoHTML.encode('utf-8'))
		f.close()

	def envia_fichero(self,ruta,fichero):
		p = Pagina(ruta + fichero)
		self.enviar_respuesta(p.tipo(), p.contenido())
            
	def envia_busqueda(self, ruta, nSer):
		b = Busqueda(ruta, nSer)
		self.enviar_respuesta(b.tipo(), b.contenido())

	def envia_busqueda_req(self, ruta, idReq):
		b = BusquedaReq(ruta, idReq)
		self.enviar_respuesta(b.tipo(), b.contenido())

	def enviar_respuesta(self, tipo, contenido):
		self.enviar_cabecera(tipo)
		self.wfile.write(contenido)		# contenido es lo que se devuelve al cliente
    
	def enviar_cabecera(self, tipo):
		self.send_response(200)
		self.send_header("Content-type","text/" + tipo)
		self.end_headers()

class Pagina:
    def __init__(self,nombre):
        self.nombre = nombre
        self.texto = ""
        fichero = file(self.nombre)
        self.texto = fichero.read()
        fichero.close()

    def contenido(self):
        return self.texto

    def tipo(self):
        tipo = "html"
        ext = self.nombre[-4:]
        if (ext == "html"):
            tipo = "html"
        elif (ext == ".xml"):
            tipo = "xml"
        elif (ext == ".css"):
            tipo = "css"
        return tipo

class Busqueda:
	def __init__(self, ruta, nSer):
		self.ruta = ruta
		self.numSerie = nSer
		self.xml = ""

	def contenido(self):
		""" Genera el fichero xml de respuesta """
		xmldoc = minidom.parse(self.ruta + 'certs.xml')
		certLista = xmldoc.getElementsByTagName('cert')
		if not self.xml:
			self.xml = "<?xml version=\"1.0\" ?>\n"
			self.xml += "<salida>" + '\n'
			for elem in certLista:
				if self.numSerie == elem.attributes["numSer"].value:
					self.xml += '\t' + elem.toxml() + '\n'
			self.xml += "</salida>"
		print self.xml
		return self.xml

	def tipo(self):
		return "xml"

class BusquedaReq:
	def __init__(self, ruta, idReq):
		self.ruta = ruta
		self.numReq = idReq
		self.xml = ""

	def contenido(self):
		""" Genera el fichero xml de respuesta """
		xmldoc = minidom.parse(self.ruta + 'requests.xml')
		reqLista = xmldoc.getElementsByTagName('request')
		if not self.xml:
			self.xml = "<?xml version=\"1.0\" ?>\n"
			self.xml += "<salida>" + '\n'
			for elem in reqLista:
				if self.numReq == elem.attributes["id"].value:
					self.xml += '\t' + elem.toxml() + '\n'
			self.xml += "</salida>"
		print self.xml
		return self.xml

	def tipo(self):
		return "xml"

# XXX 16 AGOSTO XXX
def controlCadCerts (xmldoc, idCA):
	""" Compara la fecha actual del sistema con la contenida en el atributo 
		'fechaUltRevCad' de certs.xml y devuelve un lógico indicando si la actual es 
		posterior a la almacenada.
	"""

	nodoRaiz = xmldoc.getElementsByTagName('CA')
	fechaUltRevCad = nodoRaiz[0].attributes['fechaUltRevCad'].value

	# actualizamos fecha última revisión de certificados caducados
	fechaAct = time.localtime()
	dia = str(fechaAct[2])
	mes = str(fechaAct[1])
	anyo = str(fechaAct[0])
	if len(dia) == 1:
		dia = '0' + dia
	if len(mes) == 1:
		mes = '0' + mes
	nodoRaiz[0].attributes['fechaUltRevCad'].value = dia + '-' + mes + '-' + anyo

	if comparaConFechaAct (str(fechaUltRevCad)):
		actualizaEstadosCerts(xmldoc)
		dirAct = os.getcwd()
		pathCertsXML = dirAct + '/web/CAs/' + idCA + '/certs.xml'
		xmlMod = xmldoc.toxml()
		fXml = open (pathCertsXML, 'w')
		fXml.write(xmlMod)
		fXml.close()


def actualizaEstadosCerts (xmldoc):
	"""Consulta todas las fechas de caducidad de los certificados y en el caso en 
	que alguna sea anterior a la actual cambia su <estado> a 'caducado'"""
	certsLista = xmldoc.getElementsByTagName('cert')
	l = len(certsLista)
	i=0
	modificado = False
	while i<l:
		fechaCad = certsLista[i].getElementsByTagName('fechaRev').item(0).firstChild.data		# fechaRev es la fecha de caducidad	
		if comparaConFechaAct (str(fechaCad)):
			certsLista[i].getElementsByTagName('estado').item(0).firstChild.data = 'caducado'
		i=i+1
# /XXX 16 AGOSTO XXX


# XXX 11 AGOSTO XXX
def controlCadCAs (xmldoc):
	""" Compara la fecha actual del sistema con la contenida en el atributo 
		'fechaUltAcc' de CAs.xml y devuelve un lógico indicando si la actual es 
		posterior a la almacenada."""
	nodoRaiz = xmldoc.getElementsByTagName('miARC-CAs')
	fechaUltAcc = nodoRaiz[0].attributes['fechaUltAcc'].value

	# actualizamos fecha último acceso
	fechaAct = time.localtime()
	dia = str(fechaAct[2])
	mes = str(fechaAct[1])
	anyo = str(fechaAct[0])
	if len(dia) == 1:
		dia = '0' + dia
	if len(mes) == 1:
		mes = '0' + mes
	nodoRaiz[0].attributes['fechaUltAcc'].value = dia + '-' + mes + '-' + anyo

	if comparaConFechaAct (str(fechaUltAcc)):
		actualizaEstadosCAs(xmldoc)
		dirAct = os.getcwd()
		pathCAsXML = dirAct + '/web/CAs/CAs.xml'
		xmlMod = xmldoc.toxml()
		fXml = open (pathCAsXML, 'w')
		fXml.write(xmlMod)
		fXml.close()


def actualizaEstadosCAs (xmldoc):
	"""Consulta todas las fechas de caducidad de las CAs y en el caso en 
	que alguna sea anterior a la actual cambia su <estado> a 'caducado'"""
	CALista = xmldoc.getElementsByTagName('ca')
	l = len(CALista)
	i=0
	modificado = False
	while i<l:
		fechaCad = CALista[i].getElementsByTagName('fechaRev').item(0).firstChild.data		# fechaRev es la fecha de caducidad
		if comparaConFechaAct (str(fechaCad)):
			CALista[i].getElementsByTagName('estado').item(0).firstChild.data = 'caducado'
		i=i+1


def comparaConFechaAct (fecha):		# fecha: string DD-MM-AAAA
	"""Compara la fecha pasada como argumento con la del sistema y devuelve un 
	lógico indicando si la pasada como argumento es anterior."""
	dia = int(fecha[0:2])
	mes = int(fecha[3:5])
	anyo = int(fecha[6:10])
	res = True
	tupTime = time.localtime()
	if anyo < tupTime.tm_year:
		res = True
	elif anyo > tupTime.tm_year:
		res = False
	else:
		if mes < tupTime.tm_mon:
			res = True
		elif mes > tupTime.tm_mon:
			res = False
		else:
			if dia < tupTime.tm_mday:
				res = True
			else:
				res = False
	return res
# XXX 11 AGOSTO XXX

def estaCadORev (idCA):
	""" Comprueba si la CA con idCA el pasado como argumento se encuentra 
		caducada o revocada.
	"""
	dirAct = os.getcwd()
	path = dirAct + "/web/CAs/CAs.xml"
	xmldoc = minidom.parse(path)
	CALista = xmldoc.getElementsByTagName('ca')
	l = len(CALista)
	encontrado = False
	i=0
	while i<l and not encontrado:
		if CALista[i].attributes['id'].value == idCA:
			estado = CALista[i].getElementsByTagName('estado').item(0).firstChild.data
			encontrado = True
		else:
			i=i+1
	if estado == "caducado" or estado == "revocado":
		sol = True
	else:
		sol = False
	return sol


def compFechas(f1, f2):
	""" Compara fechas, devolviento un Logico con valor True si la fecha f1 es 
		anterior a f2 o False si es al contrario o son iguales.

		El formato de las fechas pasadas como parámetros es: DD-MM-AAAA
	"""
	dia1 = f1[:2]
	dia2 = f2[:2]
	mes1 = f1[3:5]
	mes2 = f2[3:5]
	anyo1 = f1[6:]
	anyo2 = f2[6:]

	res = True
	if anyo2 > anyo1:
		res = True
	elif anyo2 < anyo1:
		res = False
	else:		
		if mes2 > mes1:
			res = True
		elif mes2 < mes1:
			res = False
		else:
			if dia2 > dia1:
				res = True
			else:
				res = False
	return res


def copiarArchivo (original, copia):
	""" Copia el archivo pasado como primer parámetro en la localización pasada 
		como segundo.

		@param1type: string
		@param2type: string
		@rtype: logico (boolean)
		@return: False/True
	"""
	arcOrig = open (original, 'r')
	arcCopia = open (copia, 'w')
	arcCopia.write(arcOrig.read())
	arcOrig.close()
	arcCopia.close()
