#!/usr/bin/env python
# -*- coding: iso-8859-1 -*-

import cgi
import cgitb; cgitb.enable()
import os
import random
import lib.miarc_xml

class CFormulario:
	""" Encargada de recoger la información del formulario ya sin errores.
	"""

	def __init__(self):
		""" Mapeo y captura de valores del formulario de creación de una nueva petición de certificado digital.
		"""
		form = cgi.FieldStorage()
		self.id = form["identificacion"].value		# NIF/CIF (Identificación)
		self.cn = form["comName"].value				# Nombre Comun (CN)
		self.sn = form["surname"].value				# Apellido (SN)
		self.o = form["org"].value					# Organizacion (O)
		self.ou = form["uniOrg"].value				# Unidad Organizativa (OU)
		self.mail = form["emaCont"].value			# Email
		self.loc = form["ciudad"].value				# Localidad
		self.st = form["provincia"].value			# Provincia
		self.pais = form["pais"].value				# Pais
		self.passw = form["password"].value			# Password
		self.firma = form["firma"].value			# Algoritmo de firma del certificado
		self.frd = form["fechaCaduc_1"].value		# FCaducidad-dia
		self.frm = form["fechaCaduc_2"].value		# FCaducidad-mes
		self.fra = form["fechaCaduc_3"].value		# FCaducidad-anyo
		self.numBits = int(form["numBits"].value)	# Numero de Bits de la PrKey
		self.exp = form["exp"].value				# Exponente de Key
		self.uso = form["uso"].value				# Uso del Certificado

		# Sobrenombre (GN)
		if form.has_key("givName") and form["givName"].value != "":
			self.gn = form["givName"].value
		else:
			self.gn = ''

		# Numero de Serie
		if form.has_key("serial") and form["serial"].value != "":
			self.serial = form["serial"].value
		else:
			self.serial = ''


class Request:
	""""""

	def get (self):
		""" Devuelve el número contenido en idRequests.txt, -1 en caso de que no 
			exista el archivo.
		"""
		dirAct = os.getcwd()
		pathIdRequests = dirAct + "/requests/idRequests.txt"
		if not os.path.exists(pathIdRequests):
			sol = 0
		else:
			f = open(pathIdRequests, 'r')
			sol = f.read()
			f.close()
		return sol


	def actualiza (self):
		""" Actualiza el archivo idRequests.txt que contiene el número id de la 
			siguiente request.
		"""
		dirAct = os.getcwd()
		pathIdRequests = dirAct + "/requests/idRequests.txt"
		if not os.path.exists(pathIdRequests):
			f = open(pathIdRequests, 'w')
			f.write ('0')
		else:
			f = open(pathIdRequests, 'r+w')
			numId = int(f.read())
			f.seek(0,0)
			f.write(str(numId+1))
		f.close()


	def generaCodigoResp (self):
		""" Genera un un código numérico cuyo formato es: numRequest + '_' + numAleatorio 
		"""
		numAleatorio = random.randrange(999999999)
		codigo =  self.get() + '_' + str(numAleatorio)
		return codigo


def generaRespHtml(codigo):
	""" Página que se mostrará al cliente tras enviar el formulario.
	"""
	htmlCode = unicode ("""<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
	<title>Petición de Certificado Digital Enviada</title>
	<link rel="stylesheet" type="text/css" href="../web/viewExit.css" media="all">
	<script type="text/javascript" src="../web/view.js"></script>
</head>
<body id="main_body" >
	<img id="top" src="../web/images/top.png" alt="">
	<img src="../web/images/miarc.jpg" alt="miARC" border="0" usemap="#myARCLogoMap" id="myARCLogo">
	<div id="form_container">
		<br>
		<form class="appnitro">
			<div class="form_description">
				<h2>Petición de Certificado Digital Enviada con Éxito.</h2>
				<p>Acaba de completar el proceso para solicitar un certificado digital. <br/>Por favor, <b>imprima o copie el código que se muestra a continuación</b> puesto que tendrá que entregarlo junto con su documentación identificativa en el momento de recogida del certificado.</p>
			</div>
			<div class="form_description" align="center">
			<li>
				<p><h2>Código: """ + codigo + """</h2><p>
				<input type='button' onclick='window.print();' value='Imprimir Código' /></p>
			</li>
			<br>
			</div>
		</form> 
		<div id="footer">
			<p align="center">Creado por Francisco José González Troyano para la Asignatura Proyecto Informático de la <a href="http://www.informatica.us.es">ETSII</a></p>
		</div>
	</div>
	<img id="bottom" src="../web/images/bottom.png" alt="">
</body>
</html>""", 'utf-8')
	print htmlCode.encode('utf-8')



if __name__ == '__main__':
	cf = CFormulario()

	dirAct = os.getcwd()
	pathRequestsXml = dirAct + """/requests/requests.xml"""
	
	objXml = lib.miarc_xml.XMLRequest(pathRequestsXml, "<requests>")
	objReq = Request()
	objReq.actualiza()
	idRequest = objReq.get()
	codigo = objReq.generaCodigoResp()
	objXml.newRequest(cf, idRequest, codigo)

	print "Content-Type: text/html\n"     # sigue HTML
	generaRespHtml(codigo)
